<?php



include("$LIBPATH/validate/sql_fragments.php");
include("$LIBPATH/validate/eval_fragments.php");


include("$LIBPATH/session/halt.func.php");


include("$NODEPATH/include/halt_msg.inc.php");


include("$LIBPATH/str/crypt.func.php");
include("$LIBPATH/str/slashes.func.php");
include("$LIBPATH/str/version.func.php");


include("$LIBPATH/base/nodeobject.class.php");
include("$LIBPATH/base/relation.class.php");
include("$LIBPATH/gui/guifactory.class.php");
include("$LIBPATH/misc/load_db_features.func.php");
include("$LIBPATH/misc/maintenance_mode.func.php");


include( "$LIBPATH/html/html_utils.func.php" );


include("$LIBPATH/session/mysession_check.func.php");
include("$LIBPATH/session/mysession_register.func.php");
include("$LIBPATH/session/mysession_var_read.func.php");
include("$LIBPATH/session/mysession_var_write.func.php");
include("$LIBPATH/session/mysession_var_reg.func.php");
include("$LIBPATH/session/mysession_create.func.php");
include("$LIBPATH/session/sync_user.class.php");


include("$LIBPATH/db/cache.func.php");
include("$LIBPATH/db/query.func.php");
include("$LIBPATH/db/mysql.func.php");
include("$LIBPATH/db/postgresql.func.php");
if ($FEATURE["ldap"]) {
 include("$LIBPATH/db/ldap.func.php");
 include("$LIBPATH/ldap/ldaphandle.func.php");
}
if ($FEATURE["oracle"]) include("$LIBPATH/db/oracle.func.php");
if ($FEATURE["mssql"]) include("$LIBPATH/db/mssql.func.php");

if ($SETTINGS["dbtype"] == "mysql") {
 $DB_NAME = "mysql";
} else if ($SETTINGS["dbtype"] == "pgsql") {
 $DB_NAME = "pgsql";
} else if ($SETTINGS["dbtype"] == "ora") {
 $DB_NAME = "ora";
} else if ($SETTINGS["dbtype"] == "mssql") {
 $DB_NAME = "mssql";
} else halt(7,'kernel.inc.php: dbtype not set or not valid. dbtype('.$SETTINGS["dbtype"].')');

include("$LIBPATH/html/html_header.func.php");
include("$LIBPATH/html/html_footer.func.php");


if ($DEBUG["echo"] || 1==1) {
 include("$LIBPATH/misc/calctime.func.php");
 include("$LIBPATH/session/debug.func.php");
}


$DB = mydb_connect($SETTINGS);



if ($DB["type"] == "mysql") {
 $MYSQL_REAL_ESCAPE_DB = $DB["handle"];
}
else {
 $MYSQL_REAL_ESCAPE_DB = null;
}


if ((isset($LOG_REQUEST) && $LOG_REQUEST) || isset($load_request)) {
 include("$LIBPATH/session/macro.inc.php");
}


if (!(function_exists("is_false"))) {
 $__php_version = substr(phpversion(),0,1);
 if ($__php_version == 3) {
 include("$LIBPATH/var/bool.func.php3");
 } elseif ($__php_version == 4 || $__php_version == 5) {
 include("$LIBPATH/var/bool.func.php");
 } else halt(4,"include/kernel.inc.php: phpversion(".phpversion().")");
}


if (!(function_exists("in_array"))) {
 include("$LIBPATH/var/in_array.func.php3");
}

if (!(function_exists("is_a"))) {
 function is_a( $object, $className ) {
 return (strtolower($className) == get_class($object) || is_subclass_of($object, $className));
 }
}

if (!(function_exists("array_key_exists"))) {
 function array_key_exists($key, $search) {
 return isset($search[$key]);
 }
}









function node_assert_handler($file, $line, $code) {
 global $DEBUG_SETTINGS;
 static $inassert = false;

 if (!$DEBUG_SETTINGS["assert"]) return;
 if ($inassert) return;
 $inassert = true;
 
 $message = "Assertion failed in <b>$file</b> on line $line.";
 $detail = "File: $file\nLine: $line\nAssertion: $code";

 BaseObject::addDebugMessage($message, $detail);
 
 $inassert = false;
}



if (($DEBUG["echo"] || $USER_ID == 1)) {
 assert_options(ASSERT_ACTIVE, 1);
 assert_options(ASSERT_WARNING, 0);
 assert_options(ASSERT_QUIET_EVAL, 1);
 assert_options(ASSERT_BAIL, 0);
 assert_options(ASSERT_CALLBACK, "node_assert_handler");
} else {
 assert_options(ASSERT_ACTIVE, 0);
}


srand((double)microtime()*1000000);




$MAGIC = mt_rand();

?>
