<?php































































































$path_install = '/usr/bin/';

$path_tools['jpgto'] = $path_install.'jpegtopnm';
$path_tools['gifto'] = $path_install.'giftopnm';
$path_tools['pngto'] = $path_install.'giftopnm';
$path_tools['tifto'] = $path_install.'giftopnm';
$path_tools['bmpto'] = $path_install.'giftopnm';

$path_tools['scale'] = $path_install.'pnmscale';
$path_tools['quant'] = $path_install.'ppmquant';
$path_tools['cut'] = $path_install.'pnmcut';
$path_tools['label'] = $path_install.'ppmlabel';

$path_tools['tojpg'] = $path_install.'ppmtojpeg';
$path_tools['togif'] = $path_install.'ppmtogif';
$path_tools['topng'] = $path_install.'pnmtopng';
$path_tools['totif'] = $path_install.'pnmtotiff';
$path_tools['tobmp'] = $path_install.'pnmtobmp';





convert_img('/tmp/test.jpg', 'width', 200, 'pixes', 200000, 'write_format', 'jpg'); 

echo fread(fopen('/tmp/convert',"r"), filesize('/tmp/convert'));




function convert_img_error ($error) {

 global $DEBUG;
 
 if (!$DEBUG['convert_img']) {

 $im = ImageCreate (300, 100);
 $c = ImageColorAllocate($im, 255, 255, 255);
 ImageFilledRectangle ($im, 0, 0, 300, 100, $c);
 $c = ImageColorAllocate($im, 0, 0, 0);
 imageString($im, 2, 10, 20, $error, $c);
 Header("Content-type: image/png\r\n");
 ImagePNG($im);
 ImageDestroy ($im);

 } else {

 echo $error;

 }

 
 die();
}



function convert_img ($filename) {


$filename_output = '/tmp/convert';

 global $path_tools, $DEBUG;

 $filename_parts = pathinfo($filename);
 
 if (strrchr($filename_parts['basename'], '.')) {
 $filename_parts['name'] = substr($filename_parts['basename'], 0, (strlen($filename_parts['basename']) - strlen($filename_parts['extension']) - 1));
 } else {
 $filename_parts['name'] = $filename_parts['basename'];
 }

 
 $argc = func_num_args();
 $argv = func_get_args();

 if ($DEBUG['convert_img']) echo ((int)$argc - 1)." arguments to process.<br>\n";


 
 

 for ($i=1; $i < $argc; $i++) {

 if ($DEBUG['convert_img']) echo 'Processing argument '.$i.': '.$argv[$i].".<br>\n";

 switch ($argv[$i]):
 case 'readformat':
 
 $readformat = $argv[++$i];
 if ($DEBUG['convert_img']) echo " Userdefined readformat is $readformat.<br>\n"; 
 break;
 case 'writeformat':
 
 $writeformat = $argv[++$i];
 if ($DEBUG['convert_img']) echo " Userdefined writeformat is $writeformat.<br>\n"; 
 break;
 case 'height':
 
 $height = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo " Height is $height.<br>\n"; 
 if ($height <= 0) convert_img_error("Height of img is <= 0: ($height)");
 if ($pixels || $xyscaleX || $xyscaleY) convert_img_error("xysize in conjunction with width ($width) or height ($height) or pixels ($pixels)");
 break;
 case 'width':
 
 $width = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo " Width is $width.<br>\n"; 
 if ($width <= 0) convert_img_error("Width of img is <= 0: ($width)");
 if ($pixels || $xyscaleX || $xyscaleY) convert_img_error("xysize in conjunction with width ($width) or height ($height) or pixels ($pixels)");
 break;
 case 'xysize':
 
 $xysizeX = (int)$argv[++$i];
 $xysizeY = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo " xysize is $xysizeX x $xysizeY.<br>\n"; 
 if ($xysizeX <= 0 || $xysizeY <= 0) convert_img_error("xysize is invalid: ($xysizeX):($xysizeY)");
 if ($width || $height || $pixels) convert_img_error("xysize in conjunction with width ($width) or height ($height) or pixels ($pixels)");
 break;
 case 'pixels':
 
 $pixels = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo " pixels is $pixels.<br>\n"; 
 if ($pixels <= 0) convert_img_error("Pixels of img is <= 0: ($pixels)");
 if ($width || $height || $xyscaleX || $xyscaleY) convert_img_error("xysize in conjunction with width ($width) or height ($height) or pixels ($pixels)");
 break;
 case 'jpeg_nooptimize':
 
 $jpeg_nooptimize = true;
 break;
 case 'jpeg_progressive':
 
 $jpeg_progressive = true;
 break;
 case 'jpeg_greyscale':
 
 $jpeg_greyscale = true;
 break;
 case 'jpeg_quality':
 
 $jpeg_quality = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo " Jpeg quality is $jpeg_quality.<br>\n"; 
 if ($jpeg_quality <= 0 || $jpeg_quality > 100) convert_img_error("Jpeg quality of img is <= 0 or > 100: ($jpeg_quality)");
 break;
 case 'comment':
 
 $comment = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo " Comment is '$comment'.<br>\n"; 
 break;
 case 'quant':
 
 $quant = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo "Color quantity is $quant.<br>\n"; 
 if ($quant <= 0) convert_img_error("Color quantitiy of img is <= 0: ($quant)");
 break;
 case 'cut':
 
 $cutL = (int)$argv[++$i];
 $cutT = (int)$argv[++$i];
 $cutW = (int)$argv[++$i];
 $cutH = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo "cut  is left($cutL) top($cutT) width($cutW) height($cutH).<br>\n"; 
 if ($cutL < 0 || $cutT < 0) convert_img_error("cut is invalid: left($cutL) < 0, top($cutT) < 0");
 break;
 case 'label':
 
 $label = $argv[++$i];
 if ($DEBUG['convert_img']) echo "Label is $label.<br>\n"; 
 break;
 case 'label_angle':
 
 $label_angle = $argv[++$i];
 if ($DEBUG['convert_img']) echo "Label angle is $label_angle.<br>\n"; 
 if ($label_angle < 0 || $label_angle > 360) convert_img_error("label_angle is invalid (0-360): ($label_angle) < 0");
 break;
 case 'label_background':
 
 $label_background = $argv[++$i];
 if ($DEBUG['convert_img']) echo "Label background color is $label_background.<br>\n"; 
 
 break;
 case 'label_color':
 
 $label_color = $argv[++$i];
 if ($DEBUG['convert_img']) echo "Label color is $label_color.<br>\n"; 
 
 break;
 case 'label_size':
 
 $label_size = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo "Label size is $label_size.<br>\n";
 if ($label_size <= 0) convert_img_error("Label size of img is <= 0: ($label_size)");
 break;
 case 'label_x':
 
 $label_x = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo "Label x position is $label_x.<br>\n";
 if ($label_x <= 0) convert_img_error("Label x position of img is <= 0: ($label_x)");
 break;
 case 'label_y':
 
 $label_y = (int)$argv[++$i];
 if ($DEBUG['convert_img']) echo "Label y position is $label_y.<br>\n";
 if ($label_y <= 0) convert_img_error("Label y position of img is <= 0: ($label_y)");
 break;
 default:
 if ($DEBUG['convert_img']) echo "Unknown command ".$argv[$i]."... ignoring.<br>\n"; 
 break;
 endswitch;
 }



 
 
 if (!$readformat) {
 $readformat = $filename_parts['extension'];
 }
 switch (strtoupper($readformat)):
 case "JPG":
 case "JPEG":
 $process['read'] = $path_tools['jpgto']." $filename";
 break;
 case "GIF":
 $process['read'] = $path_tools['gifto']." $filename";
 break;
 case "PNG":
 $process['read'] = $path_tools['pngto']." $filename";
 break;
 case "TIF":
 case "TIFF":
 $process['read'] = $path_tools['tifto']." $filename";
 break;
 case "BMP":
 $process['read'] = $path_tools['bmpto']." $filename";
 break;
 default:
 convert_img_error("Unsupported input fileformat ($readformat)");
 break;
 endswitch;
 if ($DEBUG['convert_img']) echo 'Read command is: '.$process['read']."<br>\n";



 
 
 if (!$writeformat) {
 $writeformat = $filename_parts['extension'];
 }
 switch (strtoupper($writeformat)):
 case "JPG":
 case "JPEG":
 if (!$jpeg_nooptimize) {
 $jpeg_mod .= ' --optimize';
 }
 if ($jpeg_quality) {
 $jpeg_mod .= " --quality $jpeg_quality";
 }
 if ($jpeg_progressive) {
 $jpeg_mod .= ' --progressive';
 }
 if ($jpeg_greyscale) {
 $jpeg_mod .= ' --greyscale';
 }
 if ($comment) {
 $jpeg_mod .= " --comment '".escapeshellarg($comment)."'";
 }
 $process['write'] = $path_tools['tojpg']."$jpeg_mod > $filename_output";
 break;
 case "GIF":
 if ($comment) {
 $gif_mod .= " --comment ".escapeshellarg($comment);
 }
 $process['write'] = $path_tools['togif']."$gif_mod > $filename_output";

 
 if ($quant > 256 || $quant <= 0) $quant = 256;
 break;
 default:
 convert_img_error("Unsupported output fileformat ($writeformat)");
 break;
 endswitch;

 if ($DEBUG['convert_img']) echo 'Write command is: '.$process['write']."<br>\n";


 
 if ($width > 0) {
 $scale_mod = " --width $width";
 }
 if ($height > 0) {
 $scale_mod .= " --height $height";
 }
 if ($xysizeX > 0 && $xysizeY > 0) {
 $scale_mod = " --xysize $xysizeX $xysizeY";
 }
 if ($pixels > 0) {
 $scale_mod = " --pixels $pixels";
 }
 if ($scale_mod) {
 $process['scale'] = $path_tools['scale']." $scale_mod";
 if ($DEBUG['convert_img']) echo 'Scale command is: '.$process['scale']."<br>\n";
 } else {
 if ($DEBUG['convert_img']) echo "No command for scale.<br>\n";
 }

 
 if ($cutL >= 0 && $cutT >= 0 && ($cutW > 0 || $cutH >0) ) {
 $cut_mod = ' --left '.(int)$cutL.' --top '.(int)$cutT.' --width '.(int)$cutW.' --height '.(int)$cutH;
 } 
 if ($cut_mod) {
 $process['cut'] = $path_tools['cut']." $cut_mod";
 if ($DEBUG['convert_img']) echo 'Cut command is: '.$process['cut']."<br>\n";
 } else {
 if ($DEBUG['convert_img']) echo "No command for cut.<br>\n";
 }

 
 if ($label) {
 $label_mod .= " -text ".escapeshellarg($label);
 } 
 if ($label_angle) {
 $label_mod .= " -angle ".(int)$label_angle;
 } 
 if ($label_background) {
 $label_mod .= " -background ".escapesellarg($label_background);
 } 
 if ($label_colour) {
 $label_mod .= " -colour ".escapesellarg($label_colour);
 } 
 if ($label_size) {
 $label_mod .= " -size ".(int)$label_size;
 } 
 if ($label_x) {
 $label_mod .= " -x ".(int)$label_x;
 } 
 if ($label_y) {
 $label_mod .= " -y ".(int)$label_y;
 } 
 if ($label_mod) {
 $process['label'] = $path_tools['label']." $label_mod";
 if ($DEBUG['convert_img']) echo 'Label command is: '.$process['label']."<br>\n";
 } else {
 if ($DEBUG['convert_img']) echo "No command for label.<br>\n";
 }

 
 if ($quant) {
 $quant_mod = " $quant";
 } 
 if ($quant_mod) {
 $process['quant'] = $path_tools['quant']." $quant_mod";
 if ($DEBUG['convert_img']) echo 'Quant command is: '.$process['quant']."<br>\n";
 } else {
 if ($DEBUG['convert_img']) echo "No command for quant.<br>\n";
 }

 

 
 
 $cmd = $process['read'];
 
 if ($process['scale']) $cmd .= ' | '.$process['scale'];
 
 if ($process['cut']) $cmd .= ' | '.$process['cut'];
 
 if ($process['label']) $cmd .= ' | '.$process['label'];
 
 if ($process['quant']) $cmd .= ' | '.$process['quant'];
 
 $cmd .= ' | '.$process['write'];

 
 
 if (!$DEBUG['convert_img']) {
 $res = system($cmd, $ret);
 } else {
 echo "Executed System command is : $cmd<br>\n";
 } 

}

?>
