/*
 * Note: This library requires jQuery 1.4.3 at least
 */

var infos = new Array();

// build ass box
function get_box( titel, text , actions ) {
	var ret='';
	var title = '';

	title += '<h6>'+titel+'</h6><span>';

	if (actions && add_info_actions) {
		for (sub in actions) {
			if (actions[sub]['link']) {
				title += '<a href="'+actions[sub]['link']+'"';
				if (actions[sub]['target']) title += ' target="'+actions[sub]['target']+'"';
				title += '>';
			}
			title += '<img src="'+actions[sub]['icon']+'" border=0>';
			if (actions[sub]['link']) {
				title += '</a>';
			}
		}
	}
	title += '</span>';
	ret += '<div class="boxTitle">'+title+'</div>';

	if (text) {
		ret += '<div class="boxContent">'+text+'</div>';
	}
	return ret;
}

// toggle height of ass frame
var ass_flapped=false;
function toggle_ass() {

    if ( ass_flapped ) {
        ass_flapped = false;
        document.getElementById('assInfo2').style.display = 'block';
        document.getElementById('ass').style.display = 'block';
        document.getElementById('related').style.display = 'block';
        document.getElementById('properties').style.display = 'block';
        if (document.getElementById('assistent')) document.getElementById('assistent').className = '';
        if (document.getElementById('borderContainer')) document.getElementById('borderContainer').style.height = '137px';
        top.main.document.getElementById("fsContent").rows = "*,0,165";
        document.getElementById("ass_toggle_img").src = "<?= $_GET["proxyprefix"] . $STAG_PREFIX?>?do=11&module=system&img=ass_away.gif";
    } else {
        ass_flapped = true;
        document.getElementById('assInfo2').style.display = 'none';
        document.getElementById('ass').style.display = 'none';
        document.getElementById('related').style.display = 'none';
        document.getElementById('properties').style.display = 'none';
		document.getElementById('assistent').className = 'min';
        document.getElementById('borderContainer').style.height = '37px';
        
        //document.getElementById('relatedInfos').style.display = 'none';
        document.getElementById('properties').style.display = 'none';
        
        top.main.document.getElementById("fsContent").rows = "*,0,65";
        document.getElementById("ass_toggle_img").src = "<?= $_GET["proxyprefix"] . $STAG_PREFIX?>?do=11&module=system&img=ass_come_here.gif";
    }

    if ( typeof top.tree.keepMenuThere === "function" ) {
        top.tree.keepMenuThere();
    }
}

// toggle width of ass frame
var ass_left_flapped=false;

function toggle_ass_left() {
    if ( ass_left_flapped ) {
    	ass_left_flapped = false;
              
		document.getElementById('related').style.display = 'block';
		document.getElementById('properties').style.display = 'block';
		document.getElementById('assInfo2').style.display = 'block';
		if (document.getElementById('viewsTitle')) document.getElementById('viewsTitle').style.display = 'block';
		if (document.getElementById('nodeViews')) document.getElementById('nodeViews').className = '';
		document.getElementById('historyBox').style.display = 'block';
		document.getElementById('borderContainerAssLeft').style.width = '160px';
		var ass_dynamic_status = document.getElementById('ass_dynamic_status');
		if (null != ass_dynamic_status) {
			ass_dynamic_status.style.display = 'block';
		}
		if (document.getElementById('streaminfo')) {
			document.getElementById('streaminfo').style.display = 'block';
		}
	
		top.main.document.getElementById("fsContent").cols = "165,*,0";
		top.main.ass.document.getElementById("ass_toggle_img").src = "<?=  $_GET["proxyprefix"] . $STAG_PREFIX ?>?do=11&module=system&img=ass_away.gif";
		    
		/*
		top.main.ass.document.getElementById("nodeViews").style.paddingLeft = "0px";
		    
		nodeViewChildren = top.main.ass.document.getElementById("nodeViews").childNodes;
		for (i=0; i<nodeViewChildren.length; i++) {
			nodeViewChildren[i].style.paddingTop = "0";
		}
		*/
		
		if (typeof top.menu !== 'undefined' && top.menu.move_menu === 'function') {
			top.menu.move_menu();
		}
    } else {
		ass_left_flapped = true;
		       
		document.getElementById('related').style.display = 'none';
		document.getElementById('properties').style.display = 'none';
		document.getElementById('assInfo2').style.display = 'none';
		if (document.getElementById('viewsTitle')) document.getElementById('viewsTitle').style.display = 'none';
		if (document.getElementById('nodeViews')) document.getElementById('nodeViews').className = 'min';
		document.getElementById('historyBox').style.display = 'none';
		document.getElementById('borderContainerAssLeft').style.width = '60px';
		if (document.getElementById('ass_dynamic_status') && document.getElementById('ass_dynamic_status').getElementsByTagName('td') && document.getElementById('ass_dynamic_status').getElementsByTagName('td')[2]) {
			document.getElementById('ass_dynamic_status').getElementsByTagName('td')[2].style.display = 'none';
		}
		if (document.getElementById('streaminfo')) {
			document.getElementById('streaminfo').style.display = 'none';
		}
		
		top.main.document.getElementById("fsContent").cols = "65,*,0";
		top.main.ass.document.getElementById("ass_toggle_img").src = "<?= $_GET["proxyprefix"] . $STAG_PREFIX?>?do=11&module=system&img=ass_come_here.gif";
	    
	    /*
	    top.main.ass.document.getElementById("nodeViews").style.paddingLeft = "10px";
	      
		nodeViewChildren = top.main.ass.document.getElementById("nodeViews").childNodes;
		for (i=0; i<nodeViewChildren.length; i++) {
			nodeViewChildren[i].style.paddingTop = "10";
		}
		*/
	
		if (top.menu) {
			top.menu.move_menu();
		}
    }

    if ( typeof top.tree.keepMenuThere === "function" ) {
        top.tree.keepMenuThere();
    }
}

function ass_write_layer(lay, value) {
	if ( ass_flapped && value )
		return;
	var l = get_layer(lay,false);
	if (l) {
		hide_layer(l);
		write_layer(l,value);
		show_layer(l);
	}
}

// flap box..
function toggle_info(lay) {
	if (!infos[lay]) 
		return;
	if (infos[lay]['open']) {
		ass_write_layer(lay,get_box(infos[lay]['title'],'',infos[lay]['actions']));
		infos[lay]['open'] = false;
	} else {
		ass_write_layer(lay,get_box(infos[lay]['title'],infos[lay]['text'],infos[lay]['actions']));
		infos[lay]['open'] = true;
	}
}

function restore_infobox(lay) {
	if (!infos[lay]) 
		return;
	if ( !infos[lay]['text'] )
		return;
	if (infos[lay]['open']) {
		ass_write_layer(lay,get_box(infos[lay]['title'],infos[lay]['text'],infos[lay]['actions']));
	} else {
		ass_write_layer(lay,get_box(infos[lay]['title'],'',infos[lay]['actions']));
	}
}


//generate tab row for infobox links..
function gen_info_link(name,link,icon,target) {
	var val;
	val = '<tr><td>';
	if (icon) val += '<img src="'+icon+'" border=0>';
	val += '</td><td>';
	if (link) {
		val += '<a href="'+link+'"';
		if (target) val += ' target="' + target + '"';
		val += '>';
	}
	val += name;
	if (link) {
		val += '</a>';
	}
	val += '</td></tr>';
	return val;
}

function gen_info_linklist(links) {
	var val = '';
	val += '<table border=0>';
	for (sub in links) {
		if (links[sub]['name']) {
			val += gen_info_link(links[sub]['name'],links[sub]['link'],links[sub]['icon'],links[sub]['target']);
		}
	}
	val += '</table>';
	return val;
}

function set_infobox(lay, title, value, actions) {
	if (!actions) {
		actions = new Array();
	}
	if (toggle_icon) {
		actions['flap'] = new Array();
		actions['flap']['link'] = 'javascript:toggle_info(\''+lay+'\');';
		actions['flap']['icon'] = toggle_icon;
	}

	if (!infos[lay]) {
    	infos[lay] = new Array();
		infos[lay]['open'] = true;
	}
	
	infos[lay]['title'] = title;
	infos[lay]['text'] = value;
	infos[lay]['actions'] = actions;
	if (infos[lay]['open']) {
		var val = value;
	} else {
		var val = '';
	}
	ass_write_layer(lay, get_box(title, val, actions));
}

function unset_infobox(lay) {
    infos[lay] = new Array();
	infos[lay]['open'] = true;
	ass_write_layer(lay,'');
}

function show_infobox(lay) {
	var l = get_layer(lay,false);
	if (l) {
		show_layer(l);
	}
}

function hide_infobox(lay) {
	var l = get_layer(lay,false);
	if (l) {
		hide_layer(l);
	}
}

/**
 * Populate the assInfo2 div within the ass frame with information about the pagename and current language.
 */
function setPageInformation( pageInformation ) {
	var pageInformationContainer = jQuery( "#assInfo2" );
	if (pageInformation) {

		pageInformationContainer.empty();
		if( typeof pageInformation.name !== 'undefined' && null !== pageInformation.name ) {
			pageInformationContainer.append( '<strong>' + pageInformation.name + '</strong><br/>');
		}
		if( typeof pageInformation.languageImageUrl !== 'undefined' && null !== pageInformation.languageImageUrl ) {
			pageInformationContainer.append( '<img src="' + pageInformation.languageImageUrl + '" border="0" alt="' + pageInformation.language + '" title="' + pageInformation.language + '">');
		}
		if( typeof pageInformation.languageCode !== 'undefined' && null !== pageInformation.languageCode ) {
			pageInformationContainer.append( '&nbsp;['+ pageInformation.languageCode + ']');
		}
		pageInformationContainer.show();
	}
}

function setRelatedLinks( relatedLinks ) {

	var relatedContainer = jQuery( "#related" );
	relatedContainer.empty().append( "<div class='boxContent'></div>" );
	var boxContent = relatedContainer.children();

	var numLinks = relatedLinks.length;
	for ( var i = 0; i < numLinks; i++ ) {
		var link = relatedLinks[ i ];
		link.lastClickTime = 0;

		var a = jQuery( document.createElement( "a" ) );
		a.attr( "href", link.url );
		if ( null != link.className ) {
			a.attr( "class", link.className );
		}

		// Register an onclick handler for this link
		// The eventData attribute was added in jQuery 1.4.3
		a.click({ 'link': link, 'a': a }, function(event) {
			var thisLink    = event.data.link;
			var thisA       = event.data.a;
			var currentTime = new Date().getTime();

			// Check if the last click time is within 1.2 seconds
			if ((currentTime - thisLink.lastClickTime) < 1200) {
				// Don't do any action
				return false;
			}

			thisLink.lastClickTime = currentTime;

			// Check if this link has a valid
			// callback function for onclick
			if (typeof thisLink.click === "function") {
				// Call the set function
				thisLink.click();
			} else {
				progress(window.top.menu);
			}

			return true;
		});

		a.attr( "target", link.target || "list" );
		if ( null != link.iconUrl ) {
			var img = jQuery( document.createElement( "img" ) );
			img.attr( "border", "0" );
			img.attr( "src", link.iconUrl );
			if ( null != link.iconClass ) {
				img.attr( "class", link.iconClass );
			}
			a.append( img );
		}
		if ( null != link.text ) {
			var span = jQuery( document.createElement( "span" ) );
			span.text( link.text );
			a.append( span );
		}
		boxContent.append(a);
	}
}
