<?php
function gtag_create($name,$cid = 1,$node_id,$desc) {

 global $USER_ID,$TIME,$W_CREATE, $T_TAGADMIN;

 if (!$name || !$cid) return false;
 if (gtag_exists($name,$node_id)) return false;

 
 $name = sqlslashes($name);
 $desc = sqlslashes($desc);
 
 $sql = "INSERT INTO globaltag (construct_id,name,creator,cdate,editor,edate,description) 
VALUES (".sqlf_tl_num($cid).",'$name',".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",'$desc')";
 $rs = query($sql);
 $tid = $rs["iid"];

 
 set_tag_default($tid, "global");

 
 $sql = "INSERT INTO globaltag_node (globaltag_id,node_id) VALUES (".sqlf_tl_num($tid).",".sqlf_tl_num($node_id).")";
 query($sql);

 logcmd($W_CREATE,$T_TAGADMIN,$tid,0,"gtag_create");

 return $tid;

}

function gtag_update($tid,$name,$cid,$node_id,$desc) {

 global $USER_ID, $TIME, $W_EDIT, $T_TAGADMIN;

 
 if (!$name || !$cid) return false;
 if (!$tid) halt(7,"gtag_update: no global tag_id to update. tid($tid), name($name), cid($cid), node_id($node_id), desc($desc)");
 if (gtag_exists($name,$node_id,$tid)) return false;

 
 $sql = "SELECT construct_id FROM globaltag WHERE id = ".sqlf_tl_num($tid);
 $rs = query($sql);
 $old_cid = $rs["arr"][0]["construct_id"];

 
 if ($old_cid != $cid) {
 $sql = "DELETE FROM value WHERE globaltag_id = ".sqlf_tl_num($tid)." AND static = 0";
 query($sql);
 }

 
 $name = sqlslashes($name);
 $desc = sqlslashes($desc);
 
 $sql = "UPDATE globaltag SET construct_id = ".sqlf_tl_num($cid).", name = '$name', editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME).", description = '$desc' WHERE id = ".sqlf_tl_num($tid);
 query($sql);
 $sql = "UPDATE globaltag_node SET node_id = ".sqlf_tl_num($node_id)." WHERE globaltag_id = ".sqlf_tl_num($tid);
 query($sql);

 logcmd($W_EDIT,$T_TAGADMIN,$tid,0,"gtag_update");

 return true;

}

function gtag_exists($name, $node_id, $tid = 0) {

 
 $name = sqlslashes($name);
 $sql = "SELECT count(*) AS c FROM globaltag WHERE globaltag.id != ".sqlf_tl_num($tid)." AND globaltag.name = '$name'";
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) return true;
 else return false;
}

function gtag_del($ids) {
 if (!(is_array($ids))) halt(7,"gtag_del: no valid array of tag_ids to delete: ids($ids)");

 global $W_DEL, $T_TAGADMIN;

 while (list($key,$id) = each($ids)) {
 $sql1 .= "id = ".sqlf_tl_num($key)." OR ";
 $sql2 .= "globaltag_id = ".sqlf_tl_num($key)." OR ";

 logcmd($W_DEL,$T_TAGADMIN,$key,0,"gtag_del");

 }

 $sql = "DELETE FROM globaltag WHERE $sql1 1 = 2";
 query($sql);
 $sql = "DELETE FROM value WHERE ($sql2 1 = 2) AND static = 0";
 query($sql);

}

?>
