<?php

GUIFactory::setMainGUI("main");

node_class("htmlform3");
node_class("cncontentmap");
node_class("contentrepository");

mysession_var_reg("CNMAP_BROWSE_MAP");
mysession_var_reg("CNMAP_BROWSE_SEARCH");

mysession_var_reg("CNMAP_CMD");
mysession_var_reg("CNMAP_TAGMAPOPERATION");

mysession_var_reg("CNMAP_TYPE");

mysession_var_reg("CR_ID"); 


if ($treeclick) {
 unset($CR_ID);
}

if (!$CR_ID) {
 $crSelectOptions = ContentRepository::getSelectOptions();
 if (count($crSelectOptions) > 1) {
 $REDO = 15210;
 } else if (count($crSelectOptions) == 1) {
 list($key, $val) = each($crSelectOptions);
 $CR_ID = $key;
 }
}



$type = "tagmap";

if($cmd) $CNMAP_CMD = $cmd;
if($type) $CNMAP_TYPE = $type;
if($tagmapoperation) $CNMAP_TAGMAPOPERATION = $tagmapoperation;
if($argid) {
 $CNMAP_EDIT_ARG_ID = $argid;
}

$ASSCORE = str_replace("\r","",str_replace("\n","<br>",i18n($CNMAP_TYPE == "tagmap" ? "tagmap editor general assistant" : "contentmap browser general assistant")));

function refreshNodeRelated() {
 global $CNMAP_BROWSE_SEARCH, $NODERELATED, $ICO_CONTENTMAP, $CNMAP_CMD, $DO, $STAG, $CNMAP_TYPE, $ICO_CONTENTMAP_TAGMAP;

 if( $CNMAP_TYPE == "tagmap" ) {
 $NODERELATED[$DO][0] = array( "icon" => $ICO_CONTENTMAP_TAGMAP,
 "link" => "$STAG&do=$DO&cmd=edit&argid=new",
 "text" => i18n( "New Tagmap Entry" ),
 "help" => i18n( "Create a new Tagmap Entry" ),
 "target" => "list"
 );
 } else {
 unset( $NODERELATED[$DO][0] );
 }
 if( $CNMAP_TYPE == "tagmap" && $CNMAP_CMD == "edit" ) {
 $NODERELATED[$DO][1] = array( "icon" => $ICO_CONTENTMAP_TAGMAP,
 "link" => "$STAG&do=$DO&type=tagmap&cmd=search",
 "text" => i18n( "Back to List" ),
 "help" => i18n( "Return to Tagmap List"),
 "target" => "list"
 );
 } else {
 unset( $NODERELATED[$DO][1] );
 }
}





function deleteTagmapEntry( $id ) {
 global $DB, $JS, $USER_ID;

 $sql = "SELECT * FROM tagmap WHERE id = '" . sqlf_escaped($id) . "'";
 $rs = query( $sql);

 
 if (!perm($USER_ID, T_CONTENTREPOSITORY, $rs["arr"][0]["contentrepository_id"], 2)) {
 $JS .= "alert('".i18n("You are not allowed to modify this contentrepository")."')";
 return false;
 }

 if( $rs["arr"][0]["static"] ) {
 $JS .= "alert( '" . i18n("You are not allowed to delete the reserved tagmap entry with mapname {0}",0, array( $rs["arr"][0]["mapname"] ) ) . "' );";
 return false;
 }
 $sql = "DELETE FROM tagmap WHERE id = '" . sqlf_escaped($id) . "'";
 query( $sql );
}

unset($TAGMAP_ID_CAT);




function setCategory($id) {
 global $TAGMAP_ID_CAT, $REDO;

 $TAGMAP_ID_CAT[] = $id;
 $REDO = 15217;
}

$contentmap = new CNContentmap();

$tagname = "";
$mapname = "";
$object = "";
$attributetype = "";
$multivalue = 0;
$optimized = 0;
$foreignlinkattribute = "";
$foreignlinkattributerule = "";
$objtype = "";
$static = 0;



















function copyTagmapLayout( &$form, $param ) {
 global $CR_ID, $JS;
 
 $hint = &$form->resolveComponent("hint"); 
 $copylayouttarget = &$form->resolveComponent("copylayouttarget");
 $crselector = &$form->resolveComponent("crselector");
 $copytagmapwarn = &$form->resolveComponent("copytagmapwarn");
 
 $hint->setVisible(true);
 $copylayouttarget->setVisible(true);
 $copylayouttarget->setOptional(false);
 $copytagmapwarn->setVisible(true);
 
 $form->addButton("cancelcopylayout",
 $cancelCopyLayout = new Button( i18n ( "cancel" ), false ),
 new SimpleFormAction( "cancelCopyTagmapLayout" )
 );
 
 
 $target = $copylayouttarget->getSingleSelection();
 $target = ($target === null) ? -1 : intval($target);
 if ($target >= 0) {
 $source = intval($crselector->getSingleSelection());
 
 $sql = "DELETE FROM tagmap WHERE contentrepository_id = ".sqlf_tl_num($target);
 query($sql);
 
 $sql = "INSERT INTO tagmap (
			SELECT tagname, mapname, searchname, object, objtype, attributetype, multivalue,
				static, optimized, foreignlinkattribute, NULL AS id, foreignlinkattributerule, ".sqlf_tl_num($target)." AS 'contentrepository_id'
				FROM tagmap WHERE contentrepository_id = ".sqlf_tl_num($source)."
			)";
 query($sql);
 
 
 $JS .= 'alert("' . i18n("copy_tagmap_successful") . '")';
 $CR_ID = $target;
 $crselector->setSelection($CR_ID);
 cancelCopyTagmapLayout($form, $param);
 changeCR($form, $param);
 }
}

function copyEntryToOtherCR( $id ) {
 global $COPY_TAGMAPENTRY_IDS, $REDO;
 $COPY_TAGMAPENTRY_IDS[] = $id;
 $REDO = 15204;
}




function cancelCopyTagmapLayout( &$form, $param ) {
 $copylayouttarget = &$form->resolveComponent("copylayouttarget");
 $hint = &$form->resolveComponent("hint");
 $copytagmapwarn = &$form->resolveComponent("copytagmapwarn");
 
 $copylayouttarget->clearSelection();
 $copylayouttarget->setVisible(false);
 $copylayouttarget->setOptional(true);
 $hint->setVisible(false);
 $copytagmapwarn->setVisible(false);
 
 
 $form->removeButton("cancelcopylayout");
}

$form = new HtmlForm3( "cnmap_search" );
$STATUS = "";
$where = "";

if ( $CNMAP_TYPE == "tagmap" && $CNMAP_TAGMAPOPERATION == "verify" ) {
 

 
 
 
 $sql = "SELECT c1.id AS c1id,c1.tagname AS c1tagname,c1.mapname AS c1mapname,c1.object AS c1object, c2.id AS c2id,c2.object AS c2object,c2.tagname AS c2tagname FROM tagmap AS c1 LEFT JOIN tagmap AS c2 ON c1.contentrepository_id = c2.contentrepository_id AND c1.mapname = c2.mapname AND (c1.optimized != c2.optimized OR c1.attributetype != c2.attributetype OR c1.multivalue != c2.multivalue) WHERE c1.contentrepository_ID = ".sqlf_tl_num($CR_ID)." AND (c2.id IS NOT NULL OR (c1.optimized = 1 AND c1.multivalue = 1))";
 $rs = query( $sql );
 if( count($rs["arr"]) > 0 ) {
 $conflicts = "";
 while( list( $key, $row ) = each($rs["arr"]) ) {
 
 if( $where != "" ) $where .= ",";
 $where .= sqlf_tl_num($row["c1id"]);
 if( $row["c2id"] ) {
 $conflicts .= i18n( "Mapname: '{0}' - Tagname '{1}' (Object Type: {2}) conflicts with Tagname '{3}' (Object Type: {4})",0, $row["c1mapname"],$row["c1tagname"],$row["c1object"],$row["c2tagname"],$row["c1object"] );
 $conflicts .= "<br/>";
 } else {
 $conflicts .= i18n( "Tagname '{0}' is marked as optimized and multivalue at the same time.", 0, $row["c1tagname"] ) . "<br/>";
 }
 }
 $where = "id IN ( $where )";
 $STATUS = "<br/><span style='color:red'>".i18n( "Tagmap Integrity test failed. {0} Tagmap conflicts found:", 0, count( $rs["arr"] ) )."</span><br/>$conflicts<br/><a href='$STAG&do=$DO&tagmapoperation=none'>" . i18n( "Disable Integrity Check" ) . "</a><br/><br/>";
 } else {
 
 $STATUS = "<br/><span style='color:green'>".i18n( "Tagmap Integrity successfully verified." )."</span><br/><br/>";
 $CNMAP_TAGMAPOPERATION = "";
 }
}






































node_class("itemlist3");
node_class("sqldatasource");
node_class("resultsetformatter");
node_class("dateformatter");

class AttributeTypeFormatter extends ResultsetFormatter {
 
 var $column;
 
 function AttributeTypeFormatter( $col ) {
 $this->column = $col;
 }

 function format( $row, $params = "" ) {
 $type = $row[$this->column];
 $out = "[$type] ";
 switch ($type) {
 
 case 0: $out .= "Unknown"; break;
 case 1: $out .= "Text (short)"; break;
 case 2: $out .= "Object"; break;
 case 3: $out .= "Integer"; break;
 case 4: $out .= "Binary"; break;
 case 5: $out .= "Text (long)"; break;
 case 6: $out .= "BLOB"; break;
 case 7: $out .= "Foreign Link"; break;
 default: $out .= " Undefined";
 }
 return $out;
 }
}


class ConditionalColumnDisplayFormatter extends ResultsetFormatter {
 var $column;
 var $depended_on;
 var $value;
 var $formatter;
 
 







 function ConditionalColumnDisplayFormatter($column, $depended_on, $value, $formatter = null) {
 $this->column = $column;
 $this->depended_on = $depended_on;
 $this->value = is_array($value) ? $value : array($value);
 $this->formatter = $formatter;
 }

 function format($row, $params = "") {
 if ( ! in_array($row[$this->depended_on], $this->value)) {
 return "";
 }
 if (is_null($this->formatter)) {
 return $row[$this->column];
 }
 $args = func_get_args();
 
 return call_user_func_array(array($this->formatter, 'format'), $args);
 }
}

class ObjectTypeFormatter extends ResultsetFormatter {
 var $column;

 function ObjectTypeFormatter( $col ) {
 $this->column = $col;
 }
 function format( $row, $params = "" ) {
 $type = $row[$this->column];
 $out = "[$type] ";
 switch( $type ) {
 case 0: $out = "N/A"; break;
 case 10002: $out .= "Folder"; break;
 case 10007: $out .= "Page"; break;
 case 10008: $out .= "File"; break;
 default: $out .= "Unknown"; break;
 }
 return $out;
 }
}
class BooleanFormatter extends ResultsetFormatter {
 var $column;

 function BooleanFormatter( $col ) {
 $this->column = $col;
 }
 function format( $row, $params = "" ) {
 $bool = $row[$this->column];
 if( $bool ) return "Yes";
 return "No";
 }
}

class ReservedFormatter extends ResultsetFormatter {
 var $column;
 function ReservedFormatter( $col ) {
 $this->column = $col;
 }

 function format( &$row, $params = "" ) {
 $row["changeable"] = !$row["static"];
 return $row["changeable"] ? '' : i18n( "Reserved" );
 }
}

class CnBrowseAttributeFormatter extends ResultsetFormatter {

 var $link;
 var $types;
 var $param;
 var $column;

 function CnBrowseAttributeFormatter($types, $link, $param, $column) {
 $this->link = $link;
 $this->types = $types;
 $this->param = $param;
 $this->column = $column;
 }

 function getContentType($row) {
 $cid = explode(".", $row["contentid"]);
 return $cid[0];
 }
}

class CnBrowseTextFormatter extends CnBrowseAttributeFormatter {
 
 function format ($row, $params = "") {
 global $STAG;
 
 $val = $row[$this->column];
 $name = $row["name"]; 
 $type = $this->getContentType($row);
 
 if ($val && $this->types[$type][$name]["attributetype"] == ATTR_TYPE_OBJ) {
 $param = "&".$this->param."=".$row[$this->column];
 $val = "<a href=\"javascript:".ProgressStatusInfo::buildProgressLink( $STAG."&".$this->link.$param, "list" ).
 "\" target=\"list\">".$val."</a>";
 }
 
 return $val;
 }
}

class CnBrowseIntFormatter extends CnBrowseAttributeFormatter {

 function format ($row, $params = "") {
 $val = $row[$this->column];
 $name = $row["name"];

 if (strpos($name, "timestamp") !== false) {
 $val = date("d.m.Y H:i:s", $val);
 }

 return $val;
 }
}

class CnBrowseBinaryFormatter extends CnBrowseAttributeFormatter {
 
 var $showBinary;
 
 function CnBrowseBinaryFormatter($types, $link, $param, $column, $showBinary = false) {
 parent::CnBrowseAttributeFormatter($types, $link, $param, $column);
 $this->showBinary = $showBinary;
 }
 
 function format ($row, $params = "") {
 $val = $row[$this->column];

 if ($val) {

 if (!$this->showBinary) {
 
 $size = strlen($val);
 if ($size > 1024) $size = (round(10*$size/1024)/10)."kb";
 else $size .= "b";
 
 $val = "[data; $size]";
 } else {
 $val = str_replace("\n","<br />\n", htmlspecialchars($val));
 }
 }
 
 return $val;
 }
}

$handle &= $contentmap->getCnMapHandleByKey( $CNMAP_BROWSE_MAP );


if ($CNMAP_BROWSE_SEARCH["table"] == "contentmap" || $CNMAP_BROWSE_SEARCH["table"] == "contentattribute") {
 $sql = "SELECT * FROM tagmap";
 $tagmap = query($sql, $DB );

 $quick_cols = array();
 $types = array();
 foreach ($tagmap["arr"] as $key=>$row) {
 $types[$row["object"]][$row["mapname"]] = $row;
 
 if ($row["optimized"]) $quick_cols[$row["mapname"]] = $row;
 }
}

$table = $CNMAP_BROWSE_SEARCH["table"];
if ($table == "notification") $table = $contentmap->getCnMapNotificationTableByKey( $CNMAP_BROWSE_MAP );
if( $CNMAP_TYPE == "tagmap" ) {
 $handle = $DB;
 $table = "tagmap";
} else if( $table == "tagmap" ) {
 $table = "";
}
if ($table) {

 
 $struct = mydb_desc_table( $table, $handle );
 
 unset($struct["contentrepository_id"]);
 if ($struct["contentid"]) {
 $cid = ($CNMAP_BROWSE_SEARCH["type"] != "custom") ? $CNMAP_BROWSE_SEARCH["type"]."." : "";
 $cid .= ($CNMAP_BROWSE_SEARCH["table"] == "tagmap" ||
 $CNMAP_BROWSE_SEARCH["table"] == "contentmap" && $CNMAP_BROWSE_SEARCH["id"] == "" ? "%" : $CNMAP_BROWSE_SEARCH["id"] );
 $cid = sqlslashes( $cid, $handle );
 $where = "contentid ".(strpos( $cid, "%" ) === false?"=":"LIKE")."\"".sqlf_escaped($cid)."\"";
 } else {
 $where = " contentrepository_id = " . intval($CR_ID);
 }
 node_class( "commandaction" );

 $ds = new SQLDatasource( sqlf_table($table), "*", sqlf_table($table), $where);
 if ($FEATURE['tagmap_notsearchable']) {
 $ds->setSearchable( false );
 } else {
 $ds->setSearchable( true );
 }
 
 switch ($table) {
 case "tagmap":
 $ds->setSort( "category", "ASC" );
 $ds->addColumn( "reserved", i18n( "reserved" ), false, false, "static" );
 $ds->addFormatter( "reserved", new ReservedFormatter( "reserved" ) );

 $ds->addColumn( "mapname", i18n( "mapname" ), true, true, true );
 foreach ($struct as $field=>$desc) {
 unset($fmt_obj);
 unset($fmt_col);
 if ($field == "attributetype") {
 $ds->addColumn( "lnkattributetype", i18n($field), false, false, $field );
 $fmt_obj = new AttributeTypeFormatter("attributetype");
 $fmt_col = "lnkattributetype";
 } else if ($field == "searchname" || $field == "id" ) {
 
 } else if ($field == "static") {
 
 } else if ($field == "mapname") {
 
 } else if ($field == "object" || $field == "objtype") {
 $ds->addColumn( "new".$field, i18n( $field ), false, false, $field );
 $fmt_obj = new ObjectTypeFormatter($field);
 $fmt_col = "new".$field;
 } else if ($field == "filesystem" && !$FEATURE["cr_filesystem_attributes"]) {
 
 } else {
 $ds->addColumn( $field, i18n($field), true, true, true );
 }
 if ($field == "multivalue" || $field == "optimized" || ($field == "filesystem" && $FEATURE["cr_filesystem_attributes"])) {
 $fmt_obj = new BooleanFormatter($field);
 $fmt_col = $field;
 }
 
 if (in_array($field, array("objtype",
 "foreignlinkattribute",
 "foreignlinkattributerule")))
 {
 $fmt_obj = new ConditionalColumnDisplayFormatter($field, "attributetype", array(7, 2), $fmt_obj);
 }
 if ($fmt_obj) {
 $ds->addFormatter((isset($fmt_col) ? $fmt_col : $field), $fmt_obj);
 }
 }
 $ds->addSearchableColumn( "mapname" );
 $ds->makeLink( "mapname", "mapname", "do=15202", "list", array( "id" ), array( "id" ));
 $ds->addSearchableColumn( "tagname" );

 if (perm($USER_ID, T_CONTENTREPOSITORY, $CR_ID, 2)) {
 $ds->addAction( new CommandAction(null, "category", i18n("Set Category"), "setCategory") );
 $ds->addAction( new CommandAction( $ICO_DELETE, "del", i18n( "Delete" ), "deleteTagmapEntry" ) );
 $ds->addAction( new CommandAction( null, 'copytocr', i18n( "Copy to another Content Repository" ), 'copyEntryToOtherCR' ) );
 }

 break;
 case "contentmap":
 foreach ($struct as $field=>$desc) {
 if ($field == "contentid") {
 $ds->addColumn( "lnkcontentid", i18n($field), false, false, $field );
 $ds->makeLink( "lnkcontentid", $field, "do=$DO&cbType=contentattribute", "list", "cbID", "contentid" );
 
 } else if ($field == "motherid") {
 $ds->addColumn( "lnkmotherid", i18n($field), false, false, $field );
 $ds->makeLink( "lnkmotherid", $field, "do=$DO&cbType=contentmap", "list", "cbID", "motherid", "motherid" );
 
 } else if ($field == "updatetimestamp") {
 $ds->addColumn( "dt$field", i18n($field), false, false, $field );
 $ds->addFormatter( "dt$field", new DateFormatter( $field, "d.m.Y H:i:s" ) );
 
 } else if (substr($field, 0, 6) == "quick_" && $quick_cols[$field]["attributetype"] == ATTR_TYPE_OBJ) {
 $ds->addColumn( "lnk$field", i18n($field), false, false, $field );
 $ds->makeLink( "lnk$field", $field, "do=$DO&cbType=contentmap", "list", "cbID", $field, $field );
 } else {
 $ds->addColumn( $field, i18n($field), true, true, true );
 }
 }
 break;
 case "contentattribute":
 foreach ($struct as $field=>$desc) {
 
 if ($field == "contentid") {
 $ds->addColumn( "lnkcontentid", i18n($field), false, false, $field );
 $ds->makeLink( "lnkcontentid", $field, "do=$DO&cbType=contentmap", "list", "cbID", "contentid" );

 } else if ($field == "value_text") {
 $ds->addColumn( "f_$field", i18n($field), false, false, $field );
 $ds->addFormatter( "f_$field", new CnBrowseTextFormatter( $types, "do=$DO&cbType=contentmap", "cbID", $field ) );
 
 } else if ($field == "value_int") {
 $ds->addColumn( "f_$field", i18n($field), false, false, $field );
 $ds->addFormatter( "f_$field", new CnBrowseIntFormatter( $types, "do=$DO&cbType=contentmap", "cbID", $field ) );
 
 } else if ($field == "value_bin" || $field == "value_blob" || $field == "value_clob") {
 $ds->addColumn( "f_$field", i18n($field), false, false, $field );
 $ds->addFormatter( "f_$field", new CnBrowseBinaryFormatter( $types, "do=$DO&cbType=contentmap", "cbID", $field, $CNMAP_BROWSE_SEARCH["binary"] ) );
 
 } else {
 $ds->addColumn( $field, i18n($field), true, true, true );
 }
 }
 $ds->addSearchableColumn( "name" );
 $ds->addSearchableColumn( "value_text" );
 break;
 case "notification":
 foreach ($struct as $field=>$desc) {
 $ds->addColumn( $field, i18n($field), true, true, true );
 }
 break;
 default:
 assert(0); 
 }

 if (is_object($ds)) {
 
 $ds->setDBHandle( $handle );
 
 
 $list = new ItemList3( "cnmap_browse", $ds );
 $list->setShowInfo( true );
 $list->setMaxListItems(30);
 if ($table == "tagmap") {
 $list->setGroupableColumns(array("category"));
 }
 }
}

if ($CNMAP_TYPE == "tagmap") {
 load_menu(15201, T_CONTENTREPOSITORY, $CR_ID, "", 0, array( $CNMAP_TYPE ) );
} else {
 load_menu(15201, ($CNMAP_TYPE == "tagmap" ? $T_TAGMAP_EDITOR : $T_CONTENTMAP_BROWSER ), 0, "", 0, array( $CNMAP_TYPE ) );
} 
 
?>
