<?php
GUIFactory::setMainGUI( "main" );

if ($USER_ID != 1) exit(); 





if (!isset($BOOL_OBJPROP_YES_DSKEYS)) {
 $BOOL_OBJPROP_YES_DSKEYS = array('yes', 'ja');
}

if (!isset($BOOL_OBJPROP_NO_DSKEYS)) {
 $BOOL_OBJPROP_NO_DSKEYS = array('no', 'nein');
}


if (!isset($TAKE_TREE_OFFLINE_VISIBLE)) {
 $TAKE_TREE_OFFLINE_VISIBLE = 'object.visible';
}

if (!isset($TAKE_TREE_OFFLINE_LOGFILE)) {
 $TAKE_TREE_OFFLINE_LOGFILE = $FILEPATH . '/log/datasource_import.log';
}


if (!isset($DATASOURCE_IMPORT_CONSTRUCT_ID)) {
 $DATASOURCE_IMPORT_CONSTRUCT_ID = 234;
}

if (!isset($SOURCE_TYPE_SINGLE_SELECT)) {
 $SOURCE_TYPE_SINGLE_SELECT = 1;
}

if ( ! empty($_POST['take_tree_offline_ids'])) {
 $object_visible = $TAKE_TREE_OFFLINE_VISIBLE;
 if ( ! validate_bool_ds_objprop($object_visible, T_FOLDER)) {
 echo "Will not modify the property $object_visible<br>\n";
 ob_flush();
 $object_visible = null;
 }
 $logger = new assoc_array_logger($TAKE_TREE_OFFLINE_LOGFILE);
 foreach ($_POST['take_tree_offline_ids'] as $folder_id) {
 echo "taking folder with ID $folder_id and all subfolders and pages offline<br>\n";
 ob_flush();
 take_tree_offline($folder_id, $object_visible, false, $logger);
 }
 echo "DONE<br>\n";
 exit;
}


$tmp = $HI["file"];
$tmp["var"] = "importfile";
$tmp["label"] = "File";
$hi[] = $tmp;


$tmp = $HI["hidden"];
$tmp["var"] = "source_id";
$tmp["label"] = "source_id";
$hi[] = $tmp;


$tmp = $HI["sel"];
$tmp["var"] = "DOEXEC";
$tmp["label"] = "Execute Import?";
$tmp["list"] = array(0 => "no", 1 => "yes");
$hi[] = $tmp;


$hi[] = $HI["ok"];
$hi[] = $HI["cancel"];






if (!$f_DOEXEC) {
 $DOEXEC = $f_DOEXEC = 0;
}

$f = new htmlform($hi);


$tmpfilename = "$TMPPATH/ds_importfile.tmp";
if ($importfile) {
 $fp = fopen($tmpfilename,'w');
 $bytes = fwrite($fp,$importfile);
 fclose($fp);
}


if (file_exists($tmpfilename)) {
 $fp = fopen($tmpfilename,'r');
 while (!feof($fp)) {
 $importcontents .= fgets($fp);
 }
 fclose($fp); 
}



if ($importcontents) {
 $entries = explode("\n", $importcontents);
 $sorder = 1;
 $found = array();
 
 foreach ( $entries as $entry )
 {
 
 $matches[$sorder] = explode("\t", $entry);
 $matches[$sorder][2] = $matches[$sorder][1];
 $matches[$sorder][1] = $matches[$sorder][0];
 if (trim($matches[$sorder][1]) == '' || trim($matches[$sorder][2] == '')) {
 $num = 0;
 } else {
 $num = 1;
 }
 if ( $num != 1 )
 {
 
 $difftable[$sorder]['status'] = 'warn';
 $difftable[$sorder]['dskey'] = $entry;
 $difftable[$sorder]['value'] = "<strong>Warning</strong>";
 }
 else
 {
 $sql = "SELECT * FROM datasource_value WHERE datasource_id=".sqlf_tl_num($source_id)." AND value='".sqlf_escaped($matches[$sorder][1])."'";
 $rs = query( $sql );
 
 
 if ( $rs["num"] > 0 && strlen($matches[$sorder][1]) > 0 ) {
 $found[] = $rs["arr"][0]["id"];
 
 $difftable[$sorder]['status'] = 'change';
 $difftable[$sorder]['dskey'] = '<strong>old entry:</strong> ' . 
 $rs["arr"][0]["dskey"] . ' <strong>new entry:</strong> ' . $matches[$sorder][2];
 $difftable[$sorder]['value'] = $rs["arr"][0]["value"];
 
 $sql = "UPDATE datasource_value SET sorder=".sqlf_tl_num($sorder).", dskey='".sqlslashes($matches[$sorder][2])."'".
 " WHERE datasource_id=".sqlf_tl_num($source_id)." AND value='".sqlf_escaped($matches[$sorder][1])."'";
 if ( $DOEXEC ) {
 query( $sql );
 }

 
 } else {
 $sql = "SELECT max(dsid)+1 as id FROM datasource_value WHERE datasource_id=".sqlf_tl_num($source_id);
 $rs = query( $sql );
 $maxid = (int) $rs["arr"][0]["id"];
 $sql = "INSERT INTO datasource_value (datasource_id, sorder, dskey, value, dsid) ".
 "VALUES (".sqlf_value($source_id).", ".sqlf_value($sorder).", '".sqlslashes($matches[$sorder][2])."', '".sqlf_escaped($matches[$sorder][1])."', ".sqlf_value($maxid).")";
 if ( $DOEXEC ) {
 $rs = query( $sql );
 }
 
 $found[] = $rs["iid"];

 $difftable[$sorder]['status'] = 'ins';
 $difftable[$sorder]['dskey'] = $matches[$sorder][2];
 $difftable[$sorder]['value'] = $matches[$sorder][1];

 }
 }
 $sorder++;

 }

 if( count( $found ) < 1 ) {
 echo i18n("No (valid) entries found in CSV file.");
 return;
 }

 
 $sql = "DELETE FROM datasource_value WHERE datasource_id=".sqlf_tl_num($source_id)." AND id not IN (".
 implode( ",", sqlf_value_array($found) ).")";
 if ( $DOEXEC ) {
 $rs = query( $sql );
 echo "DELETED: ".$rs["num"]." entries.\n";
 }





 $sql = "SELECT * from datasource_value WHERE datasource_id = ".sqlf_tl_num($source_id)." AND id not IN (".
 implode( ",", sqlf_value_array($found) ) . ")";
 $res = query($sql);
 if ($res["num"] > 0) {
 while (list($key,$row)=each($res["arr"])) { 
 $difftable[] = array(
 'status' => 'del',
 'dskey' => $row["dskey"], 
 'value' => $row["value"]
 );
 }
 }

 
 
 $sql = "SELECT value, dskey from datasource_value " .
 "WHERE datasource_id = ".sqlf_tl_num($source_id)." AND value != '' AND id not IN (" . implode(',', sqlf_value_array($found)) . ")";
 $res_a = query($sql);
 
 $sql = "SELECT dsid from datasource_value WHERE datasource_id = ".sqlf_tl_num($source_id)." " .
 "AND id not IN (" . implode(',', sqlf_value_array($found)) . ")";
 $res_b = query($sql);
 if ($res_b['num'] > 0) {
 
 $res_b_ids = "";
 for ($i=0;$i<$res_b['num'];$i++) {
 $res_b_ids .= sqlf_value($res_b['arr'][$i]['dsid']);
 if ($i < $res_b['num'] - 1) {
 $res_b_ids .= ',';
 }
 }
 $sql = "SELECT f4.name AS f4name,
			f3.name AS f3name,
			f2.name AS f2name,
			f1.name AS f1name,
			folder.name AS fname
		FROM objtag
		LEFT JOIN value ON objtag.id = value.objtag_id
		LEFT JOIN folder ON ( objtag.obj_id = folder.id AND objtag.obj_type = 10002 )
		LEFT JOIN folder AS f1 ON folder.mother = f1.id
		LEFT JOIN folder AS f2 ON f1.mother = f2.id
		LEFT JOIN folder AS f3 ON f2.mother = f3.id
		LEFT JOIN folder AS f4 ON f3.mother = f4.id
		WHERE objtag.construct_id = ".sqlf_tl_num($DATASOURCE_IMPORT_CONSTRUCT_ID)." AND
			value_text IN ($res_b_ids)";
 $res_c = query($sql);
 
 


 $sql = 'SELECT DISTINCT folder.id FROM objtag'
 . ' JOIN value ON objtag.id = value.objtag_id'
 . ' JOIN folder ON (objtag.obj_id = folder.id AND objtag.obj_type = 10002)'
 . ' WHERE objtag.construct_id = ' . sqlf_tl_num($DATASOURCE_IMPORT_CONSTRUCT_ID)
 . ' AND value_text IN (' . $res_b_ids . ')';
 $res = query($sql);
 $TAKE_TREE_OFFLINE_IDS = gcn_array_column($res['arr'], 'id');
 }
}



if ($DOEXEC) {
 unlink($tmpfilename);
}




function difftable($difftable) {
 echo "<table><tr><th>dskey</th><th>value</th></tr>\n";
 for ($i=1; $i<=count($difftable);$i++) {
 if ($difftable[$i]['status'] == 'ins') {
 $bgcol = '#DDFFDD';
 } else if ($difftable[$i]['status'] == 'del') {
 $bgcol = '#FFDDDD';
 } else if ($difftable[$i]['status'] == 'warn') {
 $bgcol = '#FFCC99';
 } else {
 $bgcol = 'white';
 }
 echo "<tr style=\"background-color: $bgcol;\">
				<td>". $difftable[$i]['dskey'] . "</td>
				<td>". $difftable[$i]['value'] . "</td>
			 </tr>
";
 
 }
 echo "</table>\n";
}




function printres($res) {
 if ($res['num'] > 0) {
 $numcols = count($res['arr'][0]) / 2; 
 echo "<table border=\"1\">\n";
 while (list($rkey,$row) = each($res['arr'])) {
 echo "<tr>\n"; 
 for ($i=0;$i<$numcols; $i++) {
 echo "<td>" . $row[$i] . "</td>";
 }
 echo "</tr>\n";
 }
 echo "</table>\n";
 } else {
 echo "no data in this result.<br />";
 }
}




function get_ds_objprop_info($prop, $obj_type) {
 $sql = 'SELECT ds.source_type, dsv.dskey, dsv.dsid, part.id part_id'
 . ' FROM datasource ds'
 . ' JOIN datasource_value dsv ON ds.id = dsv.datasource_id'
 . " JOIN objtag on objtag.obj_id = 0 AND objtag.name = '" . sqlslashes($prop) . "'"
 . "  AND objtag.obj_type = '" . sqlslashes($obj_type) . "'"
 . ' JOIN part ON part.construct_id = objtag.construct_id'
 . '  AND part.info_int = ds.id';
 $res = query($sql);
 return $res['arr'];
}





function get_ds_objprop_dsids($prop, $obj_type, $keys) {
 $dsids = null;
 foreach (get_ds_objprop_info($prop, $obj_type) as $row) {
 $idx = array_search(mb_strtolower($row['dskey']), $keys);
 if ($idx !== false) {
 $dsids[$keys[$idx]] = $row['dsid'];
 }
 }
 return $dsids;
}




function validate_bool_ds_objprop($prop, $obj_type) {
 global $BOOL_OBJPROP_YES_DSKEYS,
 $BOOL_OBJPROP_NO_DSKEYS,
 $SOURCE_TYPE_SINGLE_SELECT;
 $valid_keys = array_merge($BOOL_OBJPROP_YES_DSKEYS, $BOOL_OBJPROP_NO_DSKEYS);
 $part_id = null;
 foreach (get_ds_objprop_info($prop, $obj_type) as $row) {
 if ($row['source_type'] != $SOURCE_TYPE_SINGLE_SELECT) {
 return false;
 }
 if (false === array_search(mb_strtolower($row['dskey']), $valid_keys)) {
 return false;
 }
 
 if (!is_null($part_id) && $part_id != $row['part_id']) {
 return false;
 }
 $part_id = $row['part_id'];
 }
 return true;
}



















function set_bool_ds_objprop($prop, $obj_id, $obj_type, $bool_value, $logger = null) {
 $logger && $logger->log(array('setting boolean property',
 'obj_type' => $obj_type,
 'obj_id' => $obj_id,
 'property' => $prop,
 'boolean' => $bool_value ? 'true' : 'false'));

 global $BOOL_OBJPROP_YES_DSKEYS,
 $BOOL_OBJPROP_NO_DSKEYS;
 $dskeys = $bool_value ? $BOOL_OBJPROP_YES_DSKEYS : $BOOL_OBJPROP_NO_DSKEYS;

 $dsids = get_ds_objprop_dsids($prop, $obj_type, $dskeys);
 list(,$yes_value) = each($dsids);

 
 
 touch_objprop($obj_type, $obj_id);

 
 
 $sql = 'SELECT objtag.id objtag_id, value.id value_id, value.value_text, objtag.enabled'
 . ' FROM objtag JOIN value ON value.objtag_id = objtag.id'
 . " WHERE objtag.name = '" . sqlslashes($prop) . "'"
 . "   AND objtag.obj_type = '" . sqlslashes($obj_type) . "'"
 . "   AND objtag.obj_id = '" . sqlslashes($obj_id) . "'";
 $res = query($sql);
 if ($res['num']) {
 $objtag = $res['arr'][0];
 if ($objtag['value_text'] == $yes_value) {
 
 $logger && $logger->log(array('boolean property already correct',
 'objtag_id' => $objtag['objtag_id']));
 return true;
 }
 $logger && $logger->log(array('updating value',
 'value_id' => $objtag['value_id'],
 'current_value' => $objtag['value_text'],
 'new_value' => $yes_value));
 cmd_update_value(
 $yes_value,
 $objtag['info_int'], 
 false, 
 'obj', 
 $objtag['objtag_id'],
 $objtag['value_id'],
 false, 
 false, 
 false, 
 true 
 );
 }
 else {
 
 
 $sql = 'SELECT objtag.id objtag_id, part.id part_id, part.info_int, objtag.enabled'
 . ' FROM objtag JOIN part on part.construct_id = objtag.construct_id'
 . " WHERE objtag.name = '" . sqlslashes($prop) . "'"
 . "   AND objtag.obj_type = '" . sqlslashes($obj_type) . "'"
 . "   AND objtag.obj_id = '" . sqlslashes($obj_id) . "'";
 $res = query($sql);
 if ( ! $res['num']) {
 
 $logger && $logger->log('no boolean property defined');
 return false;
 }
 $objtag = $res['arr'][0];

 
 $logger && $logger->log(array('inserting value',
 'value_text' => $yes_value,
 'objtag_id' => $objtag['objtag_id'],
 'part_id' => $objtag['part_id']));
 $value_id = cmd_insert_value(
 $yes_value,
 $objtag['info_int'], 
 false, 
 'obj', 
 $objtag['objtag_id'],
 $objtag['part_id'],
 false, 
 false, 
 true 
 );
 $logger && $logger->log(array('inserted value', 'value_id' => $value_id));
 }

 
 
 if (!$objtag['enabled']) {
 $logger && $logger->log(array('enabling object tag',
 'objtag_id' => $objtag['objtag_id'],
 'current_value' => $objtag['enabled']));
 $sql = 'UPDATE objtag SET enabled = 1'
 . " WHERE objtag.id = " . sqlf_tl_num($objtag['objtag_id']);
 query($sql);
 }

 
 global $W_EDIT;
 logcmd($W_EDIT, T_OBJTAG, $objtag['objtag_id'], $obj_type, $prop);

 
 global $FEATURE;
 if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache(T_OBJTAG, $objtag['objtag_id']);
 }

 
 triggerEvent(T_OBJTAG, $objtag['objtag_id'], EVENT_UPDATE, new EventObject());

 return true;
}
















function take_tree_offline($folder_id, $prop_visible = null, $prop_value = null, $logger = null) {
 
 
 
 static $took_tree_offline = array();
 if ($took_tree_offline[$folder_id]) {
 return;
 }
 $took_tree_offline[$folder_id] = true;

 if ( ! is_null($prop_visible)) {
 set_bool_ds_objprop($prop_visible, $folder_id, T_FOLDER, $prop_value, $logger);
 }

 $sql = 'SELECT id, status FROM page'
 . ' WHERE folder_id = ' . sqlf_tl_num($folder_id);
 $res = query($sql);
 foreach ($res['arr'] as $row) {
 $page_status_offline = 3;
 if ($row['status'] != $page_status_offline) {
 $logger && $logger->log(array('taking page offline',
 'page_id' => $row['id'],
 'current_status' => $row['status']));
 page_status($row['id'], $page_status_offline); 
 }
 }

 $sql = 'SELECT id FROM folder'
 . ' WHERE mother = ' . sqlf_tl_num($folder_id);
 $res = query($sql);
 foreach ($res['arr'] as $row) {
 take_tree_offline($row['id'], $prop_visible, $prop_value, $logger);
 }
}





class assoc_array_logger {
 var $logfile;
 function assoc_array_logger($logfile) {
 $this->logfile = $logfile;
 }
 function log($data) {
 if (is_array($data)) {
 $msg = '';
 foreach ($data as $key => $val) {
 if ($msg) {
 $msg .= ', ';
 }
 if (!is_numeric($key)) {
 $msg .= $key . ' => ';
 }
 $msg .= strlen($val) ? $val : "`'";
 }
 $data = $msg;
 }
 $msg = $timestamp . $data . "\n";
 file_put_contents($this->logfile, $msg, FILE_APPEND);
 }
}


