<?php


 
 
 
 
 


function get_constructs() {
 global $constructs, $constr, $part_type_id, $NODE_ID;
 
 $part_type_id = array();
 $constructs = array();
 $constr = array();

 





 $sql = "SELECT part.id, type_id, part.construct_id, part.keyword, editable, partorder, v.value_text, construct.keyword as ckeyword
			FROM construct, construct_node c_n, part
			LEFT JOIN value v ON (v.part_id = part.id AND v.static = 1 AND v.templatetag_id = 0 AND 
									v.contenttag_id = 0 AND v.globaltag_id = 0 AND v.objtag_id = 0)
			WHERE construct.id = part.construct_id AND (part.construct_id = c_n.construct_id AND c_n.node_id = ".sqlf_tl_num($NODE_ID).")";
 $rs = query($sql,false,0,0);

 while (list($key,$row) = each($rs["arr"])) {
 $constructs[$row["construct_id"]]["_name"] = $row["ckeyword"];
 if (strtoupper($row["keyword"]) == "CN_TAGNAME") {
 $constructs[$row["construct_id"]]["_tagname"] = $row["value_text"];
 } elseif ($row["keyword"]) { 
 $constructs[$row["construct_id"]][$row["id"]] = $row["keyword"];
 $constr[$row["construct_id"]][$row["keyword"]] = $row["id"];
 }
 $part_type_id[$row["id"]] = $row["type_id"];
 }

 $ret = array();
 $ret["part_type_id"] = $part_type_id;
 $ret["constructs"] = $constructs;
 $ret["constr"] = $constr;
 
 

}


function get_next_tag($string) {
 global $constructs;

 reset($constructs);
 unset($tagpos);
 $delimeter = Array(' ','>');
 $tagids = array();

 
 while (list($id, $tag) = each($constructs)) {

 if ($tag["_tagname"]) {
 reset($delimeter);
 while (list($k, $del) = each($delimeter)) { 
 
 $pos = strpos(strtoupper($string), '<'.strtoupper($tag["_tagname"]).$del);
 
 
 
 
 if ($pos !== false) {
 
 if ($pos < $tagpos || !isset($tagpos)) {
 
 
 $tagids = array();
 $tagids[] = $id;
 $tagpos = $pos;
 } elseif ($pos == $tagpos) {
 
 
 $tagids[] = $id;
 } else {
 
 
 
 }
 }
 }
 }
 }




 if (isset($tagpos)) {
 return array($tagpos, $tagids);
 } else {
 return false;
 }
}

function get_next_prop($string, $tagid) {
 global $constructs, $part_type_id, $CN_COUNTER;

 
 $string = ltrim($string);

 
 if (substr($string, 0, 1) == ">" || substr($string, 0, 2) == "/>") {
 return false;
 }

 
 reset ($constructs[$tagid]);
 while (list($key,$val) = each($constructs[$tagid]) ) {
 
 
 if ($val && $key != "_tagname" && $key != "count" && $key != "_name") {
 if (strtoupper(substr($string, 0, strlen($val))) == strtoupper($val)) {
 $property = $val;
 $property_id = $key;
 break;
 }
 }
 }
 
 if (!$property) {
 
 if ($delimeter_pos = strpos($string, "=")) {
 $delimeter = "=";
 }
 if (($this_pos = strpos($string, " ")) && ($delimeter_pos == false || strpos($string, " ") < $delimeter_pos)) {
 $delimeter_pos = $this_pos;
 $delimeter = " ";
 }
 if (($this_pos = strpos($string, ">")) && ($delimeter_pos == false || strpos($string, ">") < $delimeter_pos)) {
 $delimeter_pos = $this_pos;
 $delimeter = ">";
 }
 $property = trim(substr($string, 0, strpos($string, $delimeter)));
 }


 return array($property_id, $property);
}





 
function ml_build_tag (&$string, $page_id, $url, $tagid) {
 global $constructs, $CN_IMPORT_PAGES, $part_type_id, $DEBUG;

 reset_global_validation_result();

 $time = new TimeLogger("bla");
 $time->start();
 
 
 $prop = array();

 $tagtype = $constructs[$tagid];
 
 if (substr(strtoupper($string), 0, strlen('<'.$tagtype["_tagname"]) ) == strtoupper('<'.$tagtype["_tagname"])) {
 
 $string = substr($string, strlen('<'.$tagtype["_tagname"]));
 } else { 
 
 halt(7,"<br><font color=red>alert: String does not start with <".$tagtype["_tagname"]." in (".substr($string, 0, 100).")</font><br>");
 }
 while ($string !== false && $string !== "" && list($property_id, $property) = get_next_prop($string, $tagid)) {

 
 $string = ltrim($string);

 
 $string = substr($string, strlen($property));
 
 
 $string = ltrim($string);

 
 if ($string[0] == "=") {
 
 $string = substr($string, 1);
 $string = ltrim($string);

 if ($DEBUG["import"]) echo "<h1>".$string."</h1>";
 if ($string[0] == "\"") {
 if ($DEBUG["import"]) echo '"';
 $prop[$property] = substr($string, 1, strpos($string, "\"", 1)-1);
 $string = substr($string, strlen($prop[$property])+2);
 } elseif($string[0] == "'") {
 if ($DEBUG["import"]) echo "'";
 $prop[$property] = substr($string, 1, strpos($string, "'", 1)-1);
 $string = substr($string, strlen($prop[$property])+2);
 } else {
 if ($DEBUG["import"]) echo "[:space:] || > || \\n";
 $spacepos = strpos($string, " ");
 $nlpos = strpos($string, "\n");
 $delimpos = strpos($string, ">");
 if ($DEBUG["import"]) echo "space: $spacepos vs $delimpos vs $nlpos<br>";
 if ($nlpos < $delimpos && is_int($nlpos)) $delimpos = $nlpos;
 if ($spacepos < $delimpos && is_int($spacepos)) $delimpos = $spacepos;
 
 $prop[$property] = substr($string, 0, $delimpos);
 if ($DEBUG["import"]) echo "<b>".ord(' ')." - ".ord('>')."</b><br>";
 
 $string = substr($string, strlen($prop[$property]));
 }
 if ($DEBUG["import"]) echo "-<br>";
 
 if ($DEBUG["import"]) echo "ready to parse the property<br>";
 $prop[$property] = ml_parse($prop[$property], $page_id, $url);
 if (is_global_validation_error()) {
 return false;
 }
 } 

 
 $ppt_id = $part_type_id[$property_id];
 if (($ppt_id == 4 || $ppt_id == 6 || $ppt_id == 8) && !is_array($prop[$property])) {
 $mixed_url = $prop[$property];
 $p_pos = strpos($mixed_url,"?");
 $a_pos = strpos($mixed_url,"#");
 if ($p_pos === false && $a_pos === false) {
 
 $cn_link = $mixed_url;
 } else {
 if ($p_pos === false) $p_pos = 0;
 if ($a_pos === false) $a_pos = 0;
 if ($p_pos > $a_pos) $start_pos = $p_pos;
 else $start_pos = $a_pos;

 if ($start_pos == 0) {
 $cn_link = $mixed_url;
 } else {
 $cn_link = substr($mixed_url, 0, $start_pos);
 $cn_param = substr($mixed_url, $start_pos);
 }

 
 



















 }
 

 
 if ($cn_link) $prop[$property] = $cn_link;
 if ($cn_param) $prop["cn_param"] = $cn_param;
 
 unset($cn_link); unset($cn_param);
 }

 }

 
 $string = ltrim($string);
 if ($string[0] == "/") {
 
 
 $string = substr($string, 2);
 } else {
 
 $string = substr($string, 1);
 }
 
 
 $nexttag_pos = strpos(strtoupper($string), "<".strtoupper($tagtype["_tagname"]));
 if (strlen($string) > $nexttag_pos) $nnexttag_pos = strpos(strtoupper($string), "<".strtoupper($tagtype["_tagname"]),$nexttag_pos+1);
 $tagend_pos = strpos(strtoupper($string), "</".strtoupper($tagtype["_tagname"]));

 
 if ($tagend_pos !== false) {
 while ($nexttag_pos < $tagend_pos && $nexttag_pos != false) {
 $nexttag_pos = strpos(strtoupper($string), "<".strtoupper($tagtype["_tagname"]),$nexttag_pos + 1);
 $tagend_pos = strpos(strtoupper($string), "</".strtoupper($tagtype["_tagname"]),$tagend_pos + 1);
 }

 $prop["cn_value"] = substr($string, 0, $tagend_pos);
 
 $string = substr($string, strlen($prop["cn_value"]."</".$tagtype["_tagname"]));
 $string = ltrim($string);
 $string = substr($string, 1);
 
 
 $prop["cn_value"] = ml_parse($prop["cn_value"], $page_id, $url);
 if (is_global_validation_error()) {
 return false;
 }
 }
 
 $time->stop();
 
 return $prop; 

}





 
function ml_parse($string, $page_id, $url, $store_tagid = 0) {
 global $FOLDER_ID, $TAG_PREFIX, $constructs, $part_type_id, $constr, $CN_IMPORT_PAGES, $CN_IMPORT_FILES;
 global $CN_IMPORT_IMAGES, $CN_IMPORT_PAGEEXTENSION, $DEBUG;
 
 reset_global_validation_result();

 if ($DEBUG["import"]) echo "parsing <font color=green>".htmlspecialchars($string)."</font><br>";
 
 
 if ($DEBUG["import"]) echo "-";
 $string = trim($string);
 if ($DEBUG["import"]) echo "-";
 while ($next_tag = get_next_tag($string)) {
 if ($DEBUG["import"]) echo "<font color=orange>-</font>";
 list($tagpos, $tagids) = $next_tag;
 if ($tagpos > 0) {
 $header = substr($string,0,$tagpos);
 
 $string = substr($string, strlen($header));
 } else {
 $header = "";
 }
 $tmp = ml_build_tag($string, $page_id, $url, $tagids[0]);
 if (is_global_validation_error()) {
 return false;
 }
 
 

 
 $construct_id = ml_besttag($tmp, $tagids);
 
 
 $_newtag = cmd_tag_generate($construct_id,$page_id,"contenttag","content");
 $_newtag["_tagname"] = $_newtag["tagname"]; unset($_newtag["tagname"]);
 $_newtag["_name"] = $_newtag["name"]; unset($_newtag["name"]);
 $tagname= $_newtag["_tagname"];

 $tags[$tagname] = $tmp;
 $tags[$tagname]["tag_id"] = $_newtag["id"];

 $template .= $header.$_newtag["_name"];
 $constr_tags[$tagname] = $construct_id;
 }
 if ($DEBUG["import"]) echo "-";

 
 $template .= $string;

 
 if (is_array($tags)) {
 
$debug = "<pre>";
 reset($tags);
 while (list($tagname, $prop) = each($tags)) {
$debug.= "\n---------------\n$tagname: ".$v."\n";
 if (!$store_tagid) {
 
 $sql = "SELECT content_id AS id, name FROM page WHERE id=".sqlf_tl_num($page_id);
 $rs = query($sql);
 $content_id = $rs["arr"][0]["id"];
 
 $this_tagid = $prop["tag_id"];
 } else {
 $this_tagid = $store_tagid;
 }
 if (is_array($prop)) {
 while (list($key, $val) = each($prop)) {
$debug.= "$key:($val)\n";
 
 if ($key == "cn_value") {
 if (isset($constr[$constr_tags[$tagname]]["text"])) {
 $part_id = $constr[$constr_tags[$tagname]]["text"];
 } else {
 $part_id = $constr[$constr_tags[$tagname]][$key];
 }
 } else {
 $part_id = $constr[$constr_tags[$tagname]][$key];
 }
 
 if ($part_id) {
 
 
 if ($part_type_id[$part_id] == 4) {
 
 $filelink = ml_getfilepath($val, dirname($url));

 
 $cn_import_page_id = $CN_IMPORT_PAGES[$filelink]["page_id"];

 if (is_int($cn_import_page_id)) {
 
 $tmp = "p".$part_id."_a";
 $tmp1 = "p".$part_id."_c";
 $val = $cn_import_page_id;
 $val1 = "a";
 } else {
 
 $tmp = "p".$part_id."_b";
 $tmp1 = "p".$part_id."_c";
 $val1 = "b";

 
 $part_todo = array();
 $part_todo["part_id"] = $part_id;
 $part_todo["type_id"] = $part_type_id[$part_id];
 $part_todo["cid"] = $constr_tags[$tagname];
 $part_todo["editable"] = 1;
 $part_todo["type"] = "content";
 $part_todo["tag_id"] = $this_tagid;
 

 if ($filelink) $CN_IMPORT_PAGES[$filelink]["parts"][] = $part_todo;
 }

 
 } elseif ($part_type_id[$part_id] == 6) {
 $tstart = TimeLogger::getMicroTime();
 
 $tmp = "p".$part_id."_a";
 $img_path = ml_getfilepath($val, dirname($url));
 $val=0;
 
 if ($CN_IMPORT_FILES[strtolower($img_path)]["id"] && $CN_IMPORT_FILES[strtolower($img_path)]["type"] == "image") {
 
 $image_id = $CN_IMPORT_FILES[strtolower($img_path)]["id"];
 } else {
 
 
 $image_id = cmd_saveimportimage($img_path, $page_id);
 }

 $val = $image_id;
 unset($image_id);
 
 } elseif ($part_type_id[$part_id] == 8) {
 

 $filelink = ml_getfilepath($val, dirname($url));
 
 $cn_import_file_id = $CN_IMPORT_FILES[strtolower($filelink)]["id"];

 if (is_int($cn_import_file_id)) {
 
 $tmp = "p".$part_id."_a";
 $tmp1 = "p".$part_id."_c";
 $val = $cn_import_file_id;
 $val1 = "a";
 } else {
 
 $tmp = "p".$part_id."_b";
 $tmp1 = "p".$part_id."_c";
 $val1 = "b";

 
 $part_todo = array();
 $part_todo["part_id"] = $part_id;
 $part_todo["type_id"] = $part_type_id[$part_id];
 $part_todo["cid"] = $constr_tags[$tagname];
 $part_todo["editable"] = 1;
 $part_todo["type"] = "content";
 $part_todo["tag_id"] = $this_tagid;

 
 if ($filelink) $CN_IMPORT_PAGES[$filelink]["parts"][] = $part_todo;
 }
 
 } elseif ($part_type_id[$part_id] == 15 || $part_type_id[$part_id] == 16 || $part_type_id[$part_id] == 17) {
 
 
 $FEATURE["help.gv.at"] = true;
 if ($FEATURE["help.gv.at"]) {
 $val = preg_replace("/<li>/i","\n<li>",$val);
 $val = trim($val);
 $val = preg_replace("/([\t ]*)\n/","</li>\n",$val);
 $val .= "</li>";
 }

 
 $val = preg_replace("/<\/li>([\n\t ]*)<li>/i","</li>\n</li>",$val);
 
 $val = preg_replace("/<(\/{0,1})li>/i","",$val);
 $tmp = "p".$part_id."_a";

 } else {
 $tmp = "p".$part_id."_a";
 }
 
 
 
 
 global $$tmp, $$tmp1;
 $$tmp = $val;
 $$tmp1 = $val1;

 part_update($part_id,$part_type_id[$part_id],$constr_tags[$tagname],1,"content",$this_tagid);
 if (is_global_validation_error()) {
 return false;
 }

 
 
 $$tmp = "";
 $$tmp1 = "";
 } 
 }
 
 $sql = "UPDATE contenttag SET enabled = 1 WHERE id = ".sqlf_tl_num($this_tagid);
 query($sql);
 
 
 }
 }
$debug .= "</pre>";
 }



 if ($store_tagid)
 return true;
 else
 return $template;
}


function get_content_type($filename) {
 $url = parse_url($base_url);
 $path_parts = pathinfo($filename);
 if (strtoupper($path_parts["extension"]) == "GIF") {
 return "image/gif";
 } elseif (strtoupper($path_parts["extension"]) == "JPG" || strtoupper($path_parts["extension"]) == "JPG") {
 return "image/jpeg";
 } elseif (strtoupper($path_parts["extension"]) == "PNG") {
 return "image/x-png";
 } else {
 return false;
 }
}


function reltofull($ref, $rel) {
global $CN_IMPORT_BASEPATH;

 $refarr = parse_url($ref);
 $relarr = parse_url($rel);
 if (!$relarr["scheme"]) $relarr["scheme"] = $refarr["scheme"];
 if (!$relarr["host"]) $relarr["host"] = $refarr["host"];
 if (!$relarr["user"]) $relarr["user"] = $refarr["user"];
 if (!$relarr["pass"]) $relarr["pass"] = $refarr["pass"];
 if (!$relarr["port"]) $relarr["port"] = $refarr["port"];
 
 if ($relarr["path"][0] != "/") {
 
 $relarr["path"] = dirname($refarr["path"])."/".$relarr["path"];
 }
 
 if ($relarr["scheme"]) $ret = $relarr["scheme"]."://";
 if ($relarr["user"]) {
 $ret .= $relarr["user"];
 if ($relarr["pass"]) $ret .= ":".$relarr["pass"];
 $ret .= "@";
 }
 if ($relarr["host"]) $ret .= $relarr["host"];
 if ($relarr["port"]) $ret .= ":".$relarr["port"];
 $ret .= "/";
 if ($relarr["path"]) $ret .= $relarr["path"];

 
 $ret = ereg_replace("/+","/",$ret);
 
 
 if ($ret[0] == "/" && substr($ret,0,strlen($CN_IMPORT_BASEPATH)) != $CN_IMPORT_BASEPATH) {
 
 $ret = $CN_IMPORT_BASEPATH.$ret;
 }
 return $ret; 
}

function get_tagproperty($source,$tag,$prop) {
 $pos = strpos(strtolower($source),"<$tag ");
 $len = strpos(substr($source,$pos),">")+1;
 $tag = substr($source,$pos,$len);
 $ltag = strtolower($tag);
 if (strpos($ltag,"$prop=\"")) {
 $sep = "\"";
 $sep2 = $sep;
 } else if (strpos($ltag,"$prop='")) {
 $sep = "'";
 $sep2 = $sep;
 } else {
 $sep = " ";
 $sep2 = "";
 }
 $propkey = "$prop=$sep2";
 $ppos = strpos(strtolower($tag),$propkey);
 if ($ppos) {
 $ppos += strlen($propkey);
 $plen = strpos(substr($tag,$ppos),$sep);
 $property = substr($tag,$ppos,$plen);
 }
 $tmp["tag_offset"] = $pos;
 $tmp["tag_length"] = $len;
 $tmp["tag"] = $tag;
 $tmp["prop"] = $property;
 $tmp["prop_offset"] = $pos+$ppos;
 $tmp["prop_length"] = $plen;
 return $tmp;
}

function get_mlproperty($source, $ml_tag, $ml_prop, $tags = Array()) {
 $offset = 0;
 do {
 $tag = get_tagproperty(substr($source,$offset), $ml_tag, $ml_prop);
 $new_offset = $tag["tag_offset"];
 $offset = $new_offset + $offset + 1;
 if ($tag["prop"]) $tags[$tag["prop"]] = true;
 } while ($new_offset);

 return $tags;
}


?>
