<?php
















global $fileUploader;
?>

<script type="text/javascript">

<?php
if ($fileUploader->isJavascriptInstanceExposed()) {
?>
	var fileUploader = null;
<?php
}
?>

$(document).ready(function()
{
<?php
if (!$fileUploader->isJavascriptInstanceExposed()) {
?>
	var fileUploader;
<?php
}

$fileFilters = $fileUploader->getFileFilters();
?>
	plupload.addI18n({
		'File extension error.': "<?php echo i18n("fileuploader.error.disallowed_filextension", 0, $fileFilters[0]['title'], $fileFilters[0]['extensions']); ?>"
	});

	fileUploader = new FileUploader($, plupload);

	fileUploader.addI18nKeys({
		'maxfilesize_exceeded': "<?php echo i18n("file upload failed. file must be smaller than {0}.", 0, $fileUploader->getMaxFilesize() . "B"); ?>"
	});
	fileUploader.setFileUrlPrefix("<?php echo $fileUploader->getFileUrlPrefix(); ?>");
	fileUploader.onSuccess(<?php echo $fileUploader->getJavascriptSuccessCallback(); ?>);
	fileUploader.onError(<?php echo $fileUploader->getJavascriptErrorCallback(); ?>);
	fileUploader.onFilesAdded(<?php echo $fileUploader->getJavascriptFilesAddedCallback(); ?>);
	fileUploader.setAutomaticUploadEnabled(<?php echo ($fileUploader->getAutomaticUploadEnabled() ? "true" : "false"); ?>);
	fileUploader.initialize(
		$("#<?php echo $fileUploader->getHtmlContainerId(); ?>"),
		"simple",
		{
			url                 : "<?php echo $fileUploader->getUploadUrl(); ?>",
			multipart_params    : <?php echo json_encode($fileUploader->getRestMultiPartData()); ?>,
			container           : '<?php echo $fileUploader->getHtmlContainerId(); ?>',
			browse_button       : '<?php echo $fileUploader->getHtmlContainerIdPrefix(); ?>_selectfile',
			drop_element        : '<?php echo $fileUploader->getHtmlContainerId(); ?>',
<?php
if (!$fileUploader->getMultiFileEnabled()) {
?>
			multi_selection     : false,
<?php
}

if ($fileUploader->getMaxFilesize() > 0) {
?>
			max_file_size       : '<?php echo $fileUploader->getMaxFilesize(); ?>',
<?php
}

if (!$fileUploader->getMultiFileEnabled()) {
?>
			multiple_queues      : false,
<?php
}
?>
	        filters : <?php echo json_encode($fileUploader->getFileFilters()) ?>,

			// Flash settings
			flash_swf_url        : '<?php echo $fileUploader->getPluploadBasePath(); ?>/js/plupload.flash.swf',
			// Silverlight settings
			silverlight_xap_url  : '<?php echo $fileUploader->getPluploadBasePath(); ?>/js/plupload.silverlight.xap'
		}
	);
});

</script>

<div id="<?php echo $fileUploader->getHtmlContainerId(); ?>" class="fileuploader_container<?php echo ($fileUploader->getMultiFileEnabled() ? " fileuploader_multifile" : ""); ?> fileuploader_simple">
	<?php ?>
	<input id="<?php echo $fileUploader->getHtmlContainerIdPrefix(); ?>_selectfile" type="image" src="?do=15&amp;text=<?php echo i18n('new file'); ?>" alt="<?php echo i18n('fileuploader.newfile'); ?>" border="0"><br />
	<br />
    <div class="filelist"></div>
    <div class="plupload_file_error"></div>
</div>
