<?php

securebyallowedips();








if( !$bundleimport_id ) {
 die("ERROR No bundleimport_id given.\n");
}

$objtypes = array( T_NODE, T_FOLDER, T_OBJPROPELEMENT, T_IMAGE, T_CONTENTREPOSITORY, T_TEMPLATE, T_CONSTRUCT_CATEGORY);
$objtypes_createonly = array(T_NODE, T_FOLDER, T_OBJPROPELEMENT, T_CONTENTREPOSITORY);

$from = " FROM bundleimportobject AS bio ";
$where = " WHERE bio.bundleimport_id = ".sqlf_tl_num($bundleimport_id)." AND bio.obj_type ";

$sql = "SELECT COUNT(bio.id) as c $from $where IN (" . implode(',', sqlf_value_array($objtypes) ) . ")";
$c = query( $sql );
echo "ADDWORK\t" . $c['arr'][0]['c'] . "\n";
ob_flush();flush();


$sql = "SELECT bio.id,bio.action,bio.udate,bio.globalprefix,bio.globalid,bio.obj_type $from $where ";

$queuedfolders = array();
$donefolders = array();

function fixfolderpermissions( $folder_id, $parentfolder_id, $parentfolder_type_id ) {
 global $donefolders;


 duplicate_perm($parentfolder_type_id, $parentfolder_id, T_FOLDER, $folder_id); 
 $donefolders[$folder_id] = true;
}


$perm = "11000000111111111111111111111111";

foreach( $objtypes as $objtype ) {
 $objs = query( $sql.' = '.sqlf_tl_num($objtype) );
 $createonly = in_array($objtype, $objtypes_createonly);

 foreach( $objs['arr'] as $row ) {
 
 if ($createonly && ($row['action'] != "created") && ($row['action'] != "copied")) {
 echo "DONEWORK\n";
 ob_flush();flush();
 continue;
 }

 set_time_limit(60); 
 
 $type = $row['obj_type'];

 $getidsql = "SELECT localid FROM mappedglobalid WHERE globalprefix = '".sqlf_escaped($row['globalprefix'])."' AND globalid = '".sqlf_escaped($row['globalid'])."' LIMIT 1";
 $getidrs = query( $getidsql );
 if( $getidrs['num'] != 1 ) {
 die("ERROR\tunable to get local id for obj_type {$type} and globalprefix {".$row['globalprefix']."}, globalid {".$row['globalid']."}: {".$row['num']."}\n");
 }
 $obj_id = $getidrs['arr'][0]['localid'];

 if( $type == T_NODE ) {
 if ($user_id) {
 perm_grant_all( T_NODE, $obj_id, $user_id );
 perm_grant_all( T_FOLDER, $obj_id, $user_id );
 } else if ($group_id) {
 perm_set_perms($group_id, T_NODE, $obj_id, $perm);
 perm_set_perms($group_id, T_FOLDER, $obj_id, $perm);
 }
 perm_grant_all( T_NODE, $obj_id, $user_id );
 perm_grant_all( T_FOLDER, $obj_id, $user_id );
 } else if( $type == T_FOLDER ) {
 
 
 $parentfoldersql = "SELECT m.id, m.type_id, f.type_id as currentfolder_type_id FROM folder AS f INNER JOIN folder AS m ON m.id = f.mother WHERE f.id = ".sqlf_tl_num($obj_id);
 $parentfolderrs = query( $parentfoldersql );
 $parentfolder_id = $parentfolderrs['arr'][0]['id'];
 $parentfolder_type_id = $parentfolderrs['arr'][0]['type_id'];
 $currentfolder_type_id = $parentfolderrs['arr'][0]['currentfolder_type_id'];
 if( $currentfolder_type_id == T_NODE ) {
 
 } else {

 
 $assertsql = "SELECT bio.id $from INNER JOIN mappedglobalid AS mid ON mid.globalprefix = bio.globalprefix AND mid.globalid = bio.globalid $where = ".sqlf_tl_num($type)." AND mid.localid = ".sqlf_tl_num($parentfolder_id);
 $assertrs = query( $assertsql );
 if( $assertrs['num'] > 0 ) {
 
 
 
 if( $donefolders[$obj_id] ) {
 fixfolderpermissions( $obj_id, $parentfolder_id, $parentfolder_type_id );
 } else {
 $queuedfolders[$obj_id] = array( 'parentfolder_id' => $parentfolder_id, 'parentfolder_type_id' => $parentfolder_type_id );
 echo "DEBUG\tqueued folder $obj_id - parent: $parentfolder_id\n";
 ob_flush();flush();
 }
 } else {
 
 fixfolderpermissions( $obj_id, $parentfolder_id, $parentfolder_type_id );
 }
 }
 } else if( $type == T_OBJPROPELEMENT ) {
 $objpropsql = "SELECT objtag.id, objtag.obj_type FROM objtag WHERE objtag.id = ".sqlf_tl_num($obj_id);
 $objproprs = query( $objpropsql );
 echo "DEBUG\tduplicate_perm(".T_OBJPROP.",".$objproprs['arr'][0]['obj_type'].",".T_OBJPROPELEMENT.",".$obj_id.")\n";
 ob_flush();flush();
 duplicate_perm( T_OBJPROP, $objproprs['arr'][0]['obj_type'], T_OBJPROPELEMENT, $obj_id );
 } else if( $type == T_IMAGE ) {
 
 $img = &NodeFactory::getStaticInstanceOf(T_IMAGE, $obj_id);
 if (is_a($img, "CNImageObject")) {
 $img->clearCache();
 } else {
 echo "ERROR\tcould not clear cache for image $obj_id\n";
 }
 } else if ($type == T_CONTENTREPOSITORY) {
 echo "DEBUG\tadd permissions on contentrepository $obj_id for ".($user_id ? "user $user_id" : "group $group_id")."\n";
 ob_flush();flush();
 if ($user_id) {
 ContentRepository::addUserPermissionsOnNewObject($obj_id, $user_id);
 } else if ($group_id) {
 ContentRepository::addGroupPermissionsOnNewObject($obj_id, $group_id);
 }
 } else if ($type == T_TEMPLATE) {
 if ($row["action"] == "excluded" || $row["action"] == "ignored") {
 echo "DEBUG\tdon't fix tagtypes for templatetags of template $obj_id, which was ".$row["action"]."\n";
 ob_flush();flush();
 } else {
 echo "DEBUG\tfix tagtypes for templatetags of template $obj_id\n";
 ob_flush();flush();
 
 
 
 $sql = "SELECT id, pub, construct_id FROM templatetag WHERE template_id = ".sqlf_tl_num($obj_id);
 $ttags = query($sql);
 while (list($key,$row) = each($ttags["arr"])) {
 tag_tpldef($row["id"], $row["construct_id"], $row["pub"]);
 }
 }
 } else if ($type == T_CONSTRUCT_CATEGORY) {
 if ($row["action"] == "created" || $row["action"] == "copied") {
 
 $sql = "INSERT INTO perm (usergroup_id, o_type, o_id, perm) select id, ".sql_num(T_CONSTRUCT_CATEGORY).", ".sql_num($obj_id).", '10000000000000000000000000000000' FROM usergroup";
 query($sql);
 } else if ($row["action"] == "deleted") {
 
 $sql = "DELETE FROM perm WHERE o_type = ".sql_num(T_CONSTRUCT_CATEGORY)." AND o_id = ".sql_num($obj_id);
 query($sql);
 }
 } else {
 echo "ERROR\tunknown type $type\n";
 ob_flush();flush();
 }

 echo "DONEWORK\n";
 ob_flush();flush();

 }

 if( $objtype == T_FOLDER ) {
 
 $lastcount = 0;
 while( ( $lastcount = count($queuedfolders) ) > 0 ) {
 foreach( $queuedfolders as $key => $val ) {
 set_time_limit(60); 

 $parentfolder_id = $val['parentfolder_id'];
 if( !$queuedfolders[$parentfolder_id] ) {
 
 fixfolderpermissions( $key, $parentfolder_id, $val['parentfolder_type_id'] );

 unset($queuedfolders[$key]);
 }
 }
 if( $lastcount == count( $queuedfolders ) ) {
 die( "ERROR\titerated over all queued folders without finding a single one to copy permissions.\n" );
 }
 }
 }
}

echo "DONE\n";
ob_flush();flush();

exit();


?>
