<?php

if ($cmd == 'update') {
 exit();
}

if ($maintenanceMode) {
?>
<script type="text/javascript">
	top.menu.location.reload();
	top.logo.location.reload();
	top.tree.location.reload();
</script>
<?php
}
?>
<style type="text/css">
#guide {
	width: 200px;
	float: right;
	border-left: 1px dotted #97C2E2;
	padding: 0px 20px 10px 20px;
	margin-top: 100px;
}
#guide ol {
	padding-left: 18px;
}
#guide li {
	margin: 6px 0px;
}
#guide li a {
	display:block;
}
#guide li a:hover {
	background-color: #FFFFCC;
	text-decoration: underline;
}
#guide li.done {
	list-style-image: url(<?php echo $ICO_CHECK_ALL;?>);
}
#guide li.inprogress {
	list-style-image: url(<?php echo $ICO_AJAXLOAD;?>);
}
#guide img {
	margin-bottom: -2px;
}
#instantmessage {
	position: absolute;
	top: 18%;
	left: 30%;
	width: 300px;
	background-color: white;
	padding: 0px 15px;
	border: 1px solid #97C2E2;
	display: none;
}
#instantmessage textarea {
	width: 100%;
	height: 100px;
}
#manualChanges {
	font-weight: bold;
	display: none;
}
#logoutput, #logoutput * {
	font-family: Monospace;
	font-size: 12px;
}
#logoutput {
	margin: 10px 0px;
	padding: 10px;
	background-color: #EFEFEF;
}
.log_warn, .log_attn, .log_done {
	font-weight: bold;
}
.log_warn, .log_error {
	color: red;
}
.log_attn {
	color: #EF8100;
}
.log_done, .log_success {
	color: green;
}
.log_info {
	color: blue;
}
.classfilesfound {
	color: #FF0000;
	font-weight: bold;
}
</style>
<?php



if ($autoupdate->isRunUpdateFlagSet()) {
 $autoupdate->downloadFile($autoupdate->getSelectedUpdateFilename());
?>
<style>
.major, .manual {
	font-size: 14px;
}
.major {
	color: #FF8827;
}
.manual {
	color: red;
	background-image: url(<?php echo $ICO_ALERT_ANI;?>);
	background-repeat: no-repeat;
	padding-left: 22px;
}
.changelog {
	border: 0px dotted #97C2E2;
	border-width: 1px 0px;
	padding-right: 20%;
}
.changelog ul li {
	padding: 3px 0px;
	margin: 3px 0px;
}
.changelog a {
	color: #FF8827;
}
li.fix {
	list-style-image: url(<?php echo $STAG;?>&do=11&module=system&img=changelog-type-fix.gif);
}
li.new {
	list-style-image: url(<?php echo $STAG;?>&do=11&module=system&img=changelog-type-new.gif);
}
li.secu {
	list-style-image: url(<?php echo $STAG;?>&do=11&module=system&img=changelog-type-secu.gif);
}
li.var {
	list-style-image: url(<?php echo $STAG;?>&do=11&module=system&img=changelog-type-var.gif);
}
</style>
<script type="text/javascript">

var currentVersion = "<?php echo prettyprint_gcnversion(get_current_gcnversion()) ?>";

function cmpVersions(a, b) {
	var i, l, d;

	a = a.split('.');
	b = b.split('.');
	l = Math.min(a.length, b.length);

	for (i=0; i<l; i++) {
		d = parseInt(a[i], 10) - parseInt(b[i], 10);
		if (d !== 0) {
			return d;
		}
	}

	return a.length - b.length;
}

/**
 * Checks all manual changelog checkboxes
 */
function checkManualChanges() {
	// Assume all changes were accepted and check all checkboxes
	var allChangesAccepted = jQuery('.confirm-change-checkbox:not(:checked)').length == 0;

	// Enable the button when the checkbox at the bottom has been checked as well
	var checked = jQuery("#confirm_changelog").is(':checked');
	if (allChangesAccepted && checked) {
		jQuery("#install_update").attr("src", "?do=15&text=<?php echo urlencode(i18n("install_update"));?>");
		jQuery("#confirm_changelog_text").attr("style","color: green");
	}
	return allChangesAccepted;
}

jQuery(document).ready(function() {
	jQuery('.version-entry').each(function() {
		var thisVersion = $(this).attr('id');
		var result = cmpVersions(currentVersion, thisVersion);
		if (result >= 0) {
			// Hide the changes since the version is older than our installed one
			$(this).hide();
		} else {
			// Append a checkbox to all manual changes
			$confirmChange = $('#confirm-change');
			$(this).find('.changelog-entry.manualchange').each(function () {
				$confirmChange.clone().removeAttr('id').appendTo($(this));
			});
		}
	});
	// Remove the temoplate container
	$('#confirm-change-template').remove();
	jQuery('.confirm-change-checkbox').click(function() {
		checkManualChanges();
	});
});

function toggleConfirm() {
	var checked = jQuery("#confirm_changelog").is(':checked');
	var allChangesAccepted = checkManualChanges();
	if (checked && allChangesAccepted) {
		jQuery("#install_update").attr("src", "?do=15&text=<?php echo urlencode(i18n("install_update"));?>");
		jQuery("#confirm_changelog_text").attr("style","color: green");
	} else {
		jQuery("#install_update").attr("src", "?do=15&text=<?php echo urlencode(i18n("install_update"));?>&disabled=true");
		jQuery("#confirm_changelog_text").attr("style","color: black");
	}
}

function triggerInstall() {
	var checked = jQuery("#confirm_changelog").is(':checked');
	var allChangesAccepted = checkManualChanges();
	if (checked && allChangesAccepted) {
		location.href="<?php echo $STAG;?>&do=1040&updatefile=<?php echo $autoupdate->getSelectedUpdateFilename();?>&cmd=spawnupdate";
	} else {
		jQuery("#confirm_changelog_text").attr("style","color: red");
		if (checked && !allChangesAccepted) {
			alert("<?php echo i18n("confirm_changes_error");?>");
		} else {
			alert("<?php echo i18n("confirm_changelog_error");?>");
		}
	}
}
</script>

<div id="confirm-change-template" style="display: none">
  <div id="confirm-change">
     <p>
        <input class="confirm-change-checkbox" type="checkbox"><strong><?php echo i18n("confirm_change");?></strong>
     </p>
  </div>
</div>

<div class="dialog">
	<h1>Changelog</h1>
	<p id="manualChanges">
		<img src="<?php echo $ICO_ALERT_ANI;?>" style="margin-bottom: -4px;" alt="<?php echo i18n("warning");?>" title="<?php echo i18n("warning");?>"/>
		<?php echo i18n("changelog_manual_changes_warn");?>
	</p>
	<p style="padding-bottom: 25px;">
		<?php echo i18n("changelog_further_info");?>
	</p>
	<p>
<?php
if (checkForJavaPatches()) {
?>
		<h2 class="classfilesfound">WARNING: .class files found in /Node/tomcat/shared/classes, not deleting patches before updating can possibly break your installation.</h2>
<?php
}
?>
		<?php echo $autoupdate->getChangelogHTMLOutput($autoupdate->getSelectedUpdateFilename()); ?>
	</p>
<?php
 if (!$clDisplayError) {
?>	
	<p id="confirm_changelog_text">
		<input type="checkbox" id="confirm_changelog" onclick="toggleConfirm();"><?php echo i18n("confirm_changelog");?>
	</p>
	<input id="install_update" type="image" border="0" alt="<?php echo i18n("install_update");?>" title="<?php echo i18n("install_update");?>" src="?do=15&amp;text=<?php echo urlencode(i18n("install_update"));?>&disabled=true" onclick="triggerInstall();"/>
<?php
 }
?>
</div>
<?php  
 return;
}

if ($cmd != 'updateprogress') {




?>
<script type="text/javascript">
GTXScheduler.init("<?php echo i18n("scheduler_status_running");?>", "<?php echo i18n("scheduler_status_suspending");?>", "<?php echo i18n("scheduler_status_suspended");?>", <?php echo (perm($USER_ID, T_TASKADMIN, "", 2)?"true":"false");?>);
</script>
<div id="instantmessage" class="shadow">
	<form method="post">
		<h3><?php echo i18n("instantmessage");?></h3>
		(<?php echo i18n("instantmessage_timeinfo");?>)
		<p><?php echo i18n("Recipient");?>: <select name="imto"><?php
 $users = user_get_visibleuserswithname($USER_ID);
 while (list($k, $user) = each($users)) {
?><option value="<?php echo $k;?>"><?php echo $user["lastname"];?></option>
<?php	 
 }
 ?></select></p>
	
		<textarea name="msg"></textarea>
		<p>
			<input type="submit" name="im" value="<?php echo i18n("sn_message_send");?>">
			<input type="button" value="<?php echo i18n("cancel");?>" onClick="jQuery('#instantmessage').fadeOut('fast');">
		</p>
	</form>
</div>
<div id="guide">
	<h3><?php echo i18n("guide_pre_update");?></h3>
	<ol>
<?php
if ($FEATURE["instantmessages"] && perm($USER_ID, T_INBOX, "", 2)) {
 
 $class = ($instantMessageSent) ? "done" : "";
?>
		<li class="<?php echo $class;?>"><a href="#" onClick="jQuery('#instantmessage').fadeIn('normal');"><img src="<?php echo $ICO_INBOX;?>" border="0"/> <?php echo i18n("send_instant_message");?></a></li>
<?php
}
if ($FEATURE["maintenance_mode"] && perm($USER_ID, $T_MAINTENANCE, "", 1)) {
 $class = (getMaintenanceMode()) ? "done" : "";
?>
		<li class="<?php echo $class;?>"><a href="<?php echo $STAG;?>&do=1040&maintenanceMode=enable&instantMessageSent=<?php echo $instantMessageSent;?>"><img src="<?php echo $ICO_MAINTENANCE;?>" border="0"/> <?php echo i18n("activate_maintenance_mode");?></a></li>
<?php
}
if (perm($USER_ID, $T_TASKADMIN, "", 2)) {
 $class = (Scheduler::getStatus() === SCHEDULER_STATUS_SUSPENDED) ? "done" : "";
?>
		<li id="guidesuspendscheduler" class="<?php echo $class;?>"><a href="#" onClick="jQuery(this).parent().attr('class', 'inprogress'); GTXScheduler.suspend();"><img src="<?php echo $ICO_TREEMENU;?>" border="0"/> <?php echo i18n("suspend_scheduler");?></a></li>
<?php
}
?>
	</ol>
	<h3><?php echo i18n("guide_post_update");?></h3>
	<ol>
		<li class="<?php echo $class;?>"><a href="?do=7" target="_top" alt="<?php echo i18n("guide_selfupdate_logout_alt") ?>"><img src="<?php echo $ICO_LOGOUT; ?>" border="0"/><?php echo i18n("guide_selfupdate_logout")?>.</a></li>
	</ol>
</div>
<?php
 
 echo $form->getHtmlOutput();
?>
<div class="dialog">
<?php
 
 if ($showlog) {
 $logfileOuput = $autoupdate->getLogfileHTMLOutput($showlog);
?>
	<h1>Update Log <?php echo $showlog;?></h1>
	<input type="image" border="0" alt="<?php echo i18n("back");?>" title="<?php echo i18n("back");?>" src="?do=15&amp;text=<?php echo i18n("back");?>" onclick="location.href='<?php echo $STAG;?>&do=1040'"/>
	<div id="logoutput"><?php echo $logfileOuput;?></div>
	<input type="image" border="0" alt="<?php echo i18n("back");?>" title="<?php echo i18n("back");?>" src="?do=15&amp;text=<?php echo i18n("back");?>" onclick="location.href='<?php echo $STAG;?>&do=1040'"/>
<?php
 } else {
 
?>
	<h1><?php echo i18n("Update History");?></h1>
	<?php echo $updatelog->getHTMLOutput();?>
<?php
 }
?>
</div>
<?php
} else {



?>
<style>
#updatestatus li {
	padding: 5px 0px 5px 22px;
	color: #788198;
	list-style-type: none;
}
#updatestatus .active,#updatestatus  .error {
	color: black;
	background-image: url(<?php echo $STAG;?>&do=11&module=system&img=ajax-load.gif);
	background-repeat: no-repeat;
	background-position: 0px 3px;
}
#updatestatus .error {
	color: red;
	background-image: url(<?php echo $ICO_ALERT_ANI;?>);
}
#updatestatus .done {
	color: black;
	background-image: url(<?php echo $STAG;?>&do=11&module=system&img=hackerl.gif);
	background-repeat: no-repeat;
	background-position: 0px 8px;
}
</style>
<div id="guide">
	<h3><?php echo i18n("guide_post_update");?></h3>
	<ol>
<?php
if (perm($USER_ID, $T_TASKADMIN, "", 2)) {
$class = (Scheduler::getStatus() === SCHEDULER_STATUS_RUNNING) ? "done" : "";
?>
		<li id="guideresumescheduler" class="<?php echo $class;?>"><a href="#" onClick="GTXScheduler.resume();"><img src="<?php echo $ICO_TREEMENU;?>" border="0"/> <?php echo i18n("resume_scheduler");?></a></li>
<?php
}
if ($FEATURE["maintenance_mode"] && perm($USER_ID, $T_MAINTENANCE, "", 1)) {
$class = (!getMaintenanceMode()) ? "done" : "";
?>
		<li class="<?php echo $class;?>"><a href="<?php echo $STAG;?>&do=1040&maintenanceMode=disable&cmd=updateprogress"><img src="<?php echo $ICO_MAINTENANCE;?>" border="0"/> <?php echo i18n("deactivate_maintenance_mode");?></a></li>
<?php
}
?>
	</ol>
</div>
<div class="dialog">
	<h1>Update in Progress...</h1>
	<ul id="updatestatus">
		<li id="updatestatus_init"><?php echo i18n("updatestatus_init");?></li>
		<li id="updatestatus_extracting"><?php echo i18n("updatestatus_extracting");?></li>
		<li id="updatestatus_changelog"><?php echo i18n("updatestatus_changelog");?></li>
		<li id="updatestatus_update_nodecore"><?php echo i18n("updatestatus_update_nodecore");?></li>
		<li id="updatestatus_update_java"><?php echo i18n("updatestatus_update_java");?></li>
		<li id="updatestatus_restart_tomcat"><?php echo i18n("updatestatus_restart_tomcat");?></li>
		<li id="done"><?php echo i18n("done");?></li>
	</ul>
	<input type="image" border="0" alt="<?php echo i18n("back");?>" title="<?php echo i18n("back");?>" src="?do=15&amp;text=<?php echo i18n("back");?>" onclick="location.href='<?php echo $STAG;?>&do=1040'"/>
</div>
<script type="text/javascript">
GTXAutoUpdateStatus.init();
GTXScheduler.init("<?php echo i18n("scheduler_status_running");?>", "<?php echo i18n("scheduler_status_suspending");?>", "<?php echo i18n("scheduler_status_suspended");?>", <?php echo (perm($USER_ID, T_TASKADMIN, "", 2)?"true":"false");?>);
</script>
<?php	
}
?>