<?php






function load_language($lang,$user = false) {
 global $RESTRICT_DIC, $DEBUG, $METALANGUAGE_ID, $DB, $FEATURE;

 $db = $user?$DB:getDicDBHandle();

 $dic = ($user)?"dicuser":"dic";
 $output = ($user)?"outputuser":"output";

 $sql = "SELECT $dic.value, $output.id FROM $dic, $output WHERE $dic.output_id = $output.id AND $dic.language_id = ".sqlf_tl_num($lang);
 if ($RESTRICT_DIC) $sql .= " AND $output.enabled = 1";
 
 $dic = array();
 
 $rs = query($sql,1,0,$db);
 while (list($key,$row) = each($rs["arr"])) {
 if ($lang == $METALANGUAGE_ID) {
 $dic[strtolower($row["value"])] = $row["id"];
 } else {
 $dic[$row["id"]] = $row["value"];
 } 
 if ($DEBUG["echo"] && $DEBUG["dic"]) $dic[$row["id"]] .= " (d:".$row["id"].")";
 }

 return $dic;
}












function load_dictionary($language, $user = false) {
 global $DIC_SOURCE, $NODEPATH, $FEATURE;

 static $DIC_CACHE;
 
 if (is_array($DIC_CACHE[$language][$user])) {
 return $DIC_CACHE[$language][$user];
 }

 
 if ($DIC_SOURCE == "db" || $user) $DIC = load_language($language,$user);
 else if ($language) {
 if ($FEATURE["UTF8"]) $tmp = "utf8.";
 else $tmp = "";
 include($NODEPATH."/languages/".((int) $language).".".$tmp."dic.php");
 }

 $DIC_CACHE[$language][$user] = $DIC;

 return $DIC;
}





function &getDicDBHandle() {
 global $DIC_DB, $DIC_DB_HANDLE, $SETTINGS;
 if (!isset($DIC_DB_HANDLE)) {
 $DIC_DB_HANDLE = mydb_connect($DIC_DB?$DIC_DB:$SETTINGS);
 }
 return $DIC_DB_HANDLE;
}


global $DIC, $LANGUAGE;
$DIC = load_dictionary($LANGUAGE);

?>
