<?php
global $FEATURE,$FILEPATH,$MODULE;

GUIFactory::setMainGUI( "main" );
node_include("perm");
if(!perm( $USER_ID, T_DEVTOOLS, '', 0 )) {
 halt(7, "Permission denied!");
}


function getRedundantCount() {
 global $FEATURE, $FILEPATH, $MODULE;
 
 $redundant = 0;
 if($FEATURE["contentfile_data_to_db"]) {
 $sql = "select contentfile.id as cid from contentfile join folder on contentfile.folder_id=folder.id join node on folder.node_id=node.id where publish_fs = 0";
 $rs = query($sql);
 while(list($key, $val) = each($rs["arr"])) {
 if(file_exists("$FILEPATH/$MODULE/dbfiles/".$val["cid"].".bin")) {
 $redundant += 1;
 }
 }
 } else {
 $sql = "select count(*) as c from contentfiledata";
 $rs = query($sql);
 $redundant = $rs["arr"][0]["c"];
 }
 return $redundant;
}

if($cmd == "fix") {
 if($FEATURE["contentfile_data_to_db"]) {
 
 $sql = "SELECT contentfile.id AS id FROM contentfile LEFT JOIN contentfiledata on contentfile.id=contentfiledata.contentfile_id where contentfiledata.contentfile_id is NULL";
 $rs = query($sql);
 while (list($k,$p)=each($rs["arr"])) {
 $fn = "$FILEPATH/$MODULE/dbfiles/".$p["id"].".bin";
 $data = fread(fopen($fn,"rb"),filesize($fn));
 $sql = "INSERT INTO contentfiledata (contentfile_id, binarycontent) values ('".sqlf_escaped($p["id"])."', '".sqlslashes($data)."')";
 query($sql);
 }
 } else {
 $sql = "select id from contentfile";
 $rs = query($sql);
 while (list($k,$p)=each($rs["arr"])) {
 
 if(!file_exists("$FILEPATH/$MODULE/dbfiles/".$p["id"].".bin")) {
 $datars = query("SELECT binarycontent FROM contentfiledata WHERE contentfile_id=".sqlf_tl_num($p["id"]));
 $fp = @fopen("$FILEPATH/$MODULE/dbfiles/".$p["id"].".bin", "w");
 if (!$fp) halt(7,"Could not write to $FILEPATH/$MODULE/dbfiles/".$p["id"].".bin");
 fwrite($fp,$datars["arr"][0]["binarycontent"]);
 fclose($fp);
 }
 }
 }
}

$status = true;
$redundant = getRedundantCount();
if($FEATURE["contentfile_data_to_db"]) {
 $sql = "SELECT count(*) AS c FROM contentfile LEFT JOIN contentfiledata on contentfile.id=contentfiledata.contentfile_id where contentfiledata.contentfile_id is NULL";
 $rs = query($sql);
 if($rs["arr"][0]["c"] > 0) {
 $status = false;
 }

} else {
 $sql = "select id from contentfile";
 $rs = query($sql);
 while (list($k,$p)=each($rs["arr"])) {
 if(!file_exists("$FILEPATH/$MODULE/dbfiles/".$p["id"].".bin")) {
 $status = false;
 }
 }
}



if($cmd == "fix" && $status && $redundant>0) {
 if($FEATURE["contentfile_data_to_db"]) {
 
 $sql = "select contentfile.id as cid from contentfile join folder on contentfile.folder_id=folder.id join node on folder.node_id=node.id where publish_fs = 0";
 $rs = query($sql);
 while(list($key, $val) = each($rs["arr"])) {
 @unlink("$FILEPATH/$MODULE/dbfiles/".$val["cid"].".bin");
 }
 } else {
 $sql = "DELETE FROM contentfiledata";
 query($sql);
 }
 
 $redundant = getRedundantCount();
}
?>
