<?php

if (!$realid) halt(7,"no realid for real viewing page: realid($realid)");

if (!$realid && $PAGE_ID) $realid = $PAGE_ID;

$page_info = get_pageinfo($realid);


if ( ! perm_can_view_page($page_info["id"])) {
 GUIFactory::setMainGUI("main");
 $JS .= "alert('".i18n("cn_permission_denied_view_page")."');history.back();";
 return;
}


if ( $real == "edit"
 && !perm_can_edit_page($page_info["id"]))
{
 $JS .= "alert('".i18n('no_write_permission_page_error')."');";
 
 $REDO = 14001;
 return;
}


$IS_REALEDITING = true;
mysession_var_reg("FOLDER_ID");

mysession_var_reg("PAGE_ID");
$PAGE_ID = $realid;

$sql = "SELECT folder.id, folder.node_id FROM page, folder WHERE page.folder_id = folder.id AND page.id = ".((int)$realid);
$rs = query($sql);
$FOLDER_ID = $rs["arr"][0]["id"];



$editorversion = $page_info['editorversion'];

if ($real == "pub") {
 cmd_page_pub($realid);
 $real = "view";
} elseif ($real == "save") {
 cmd_page_save($realid);
 $real = "view";
} elseif ($real == "delete") {
 cmd_page_del(array($PAGE_ID => $PAGE_ID));
 $real = "close";
 $JS .= "
		// don't use refresh() on opener.location since it will most likely be a posted page
		// and therefore prompt the user. all we want to happen though is making the deleted
		// page vanish from the page list WITHOUT any prompts
		parent.opener.document.location = parent.opener.document.location;
	";
}

if ($editorversion == ALOHA) {
 if ($real != "edit") {
 $real = "view";
 }
 header( 'Location: ' . $PORTLETAPP_PREFIX . 'alohapage?realid='.$realid.'&language='.$LANGUAGE.'&sid='.$SID.'&real='.$real.'&nodeid='.$NODE_ID);
 
 mysession_var_write($SID);
 exit;
}

if ($real == "close" && $REALEDIT_BACK) {
 foreach ($REALEDIT_BACK as $var=>$val) {
 $$var = $val;
 }
 mysession_var_unreg("REALEDIT_BACK");
 return;
} else if ($real == "close" && !$REALEDIT_BACK) {
 $JS .= "top.window.close();";
}

if ($realback) {
 mysession_var_reg("REALEDIT_BACK");
 $REALEDIT_BACK = $realback;
}

$realback = $REALEDIT_BACK;

$DO_TAGFILL_BACK = 14012;
$PUBWAY = "real";

GUIFactory::setMainGUI("dialog");
$main = &GUIFactory::getMainGUI();
$main->setCSSEnabled( FALSE );


if ($FEATURE["no_pageedit_js"]) {
 $main->setMinimalJSEnabled( TRUE );
}

$main->includeJS( "tools" );
$main->includeJS( "layer" );
$main->includeJS( "superedit" );
$main->includeJS( "jquery-1.4.2.min" );
$main->includeJS( "contextmenu" );
$main->includeJS( "httprequest" );
$main->includeBodyJS( "wz_dragdrop" );

$editperm = perm($USER_ID,$T_FOLDER,$FOLDER_ID, 13, $page_info['contentgroup_id'], $T_PAGE, 12);

if ($real == "edit" && $editperm) {
 $editable = lock($realid,"page");
} else $editable = false;
if (!$editable) $real = "view";

if ($wikinoback == "true") {
 mysession_var_reg("wikinoback");
}

$page = get_page_source($realid);
$source = $page["source"];
$ml = $page["ml"];

$page = get_pageinfo($realid);
$template_id = $page["tid"];
$content_id = $page["cid"];


$tagmod = 0;


$sql = "SELECT part.id as partid, contenttag.id as contenttag_id  FROM part, contenttag ".
 "LEFT JOIN value  on ( value.contenttag_id = contenttag.id ) ".
 "WHERE part.editable=2 AND contenttag.construct_id = part.construct_id ".
 "AND value.part_id IS NULL AND contenttag.content_id = ".sqlf_tl_num($content_id);
$rs = query( $sql );
foreach ( $rs["arr"] as $row )
{
 cmd_insert_value( "", false, false, "content", $row["contenttag_id"], $row["partid"] );
 $tagmod++;
}


$tagmod += tag_copy($template_id,"template",$content_id,"content");

if ($FEATURE['javaparser'] && (!$FEATURE['disable_javaparser_foredit'] || $real == 'view')) {

 node_class("cnpageobject");
 $baseObj = new CNPageObject($realid);
 node_class("codeparser");
 $parser = new CodeParser($baseObj, false, true, $real == 'view' ? CN_EM_REALPREVIEW : CN_EM_REALEDIT, false);
 $source = $parser->render();
 $INPAGEEDIT_TAGS = $parser->getInlineEditableTags();
} else {

 if ($FEATURE["xnl"]) {
 node_class("cnpageobject");
 $baseObj = new CNPageObject($realid);
 
 $xnlParser = &ParserFactory::getInstanceOf("xnl");
 $xnlParser->setShowErrors(false);
 $xnlParser->setEvaluate(!$editable);
 $xnlParser->setBaseObject($baseObj);
 $xnlParser->setHandleDependencies(false);
 
 $xnlFuncParser =& $xnlParser->getObjectParser( "func" );
 $xnlFuncParser->addParam( "gti_is_dynamic", "1" );
 $xnlFuncParser->addParam( "gti_session_id", $SESSION_TOKEN );
 
 $xnlParser->clearEventMap();
 }
 
 $tags = translate_pagecontent($realid,$editable);
 
 if ( isSupereditEnabled(T_PAGE, true) )
 $invalid_tags = find_tag_errors( $tags );
 else
 $invalid_tags = array();
 
 if ( count( $invalid_tags ) )
 {
 $REDO = 10020;
 $o_type = "page";
 $redo = $DO;
 return;
 }
 
 $source = code_translate($source,$tags,"page",$editable,Array(),$T_PAGE,$realid);
 
 
 if ($FEATURE["xnl"]) {
 $source = $xnlParser->parse($source);
 }
}


 global $backparam;
 $backparam= "realid|$realid";
 $JS .= "backparam='$backparam';\n";
 
 if (isSupereditEnabled(T_PAGE) && $editable) {
 if (!$INPAGEEDIT_TAGS) $INPAGEEDIT_TAGS = Array();
 $TJS .= get_inpageeditable_tag_javascript($INPAGEEDIT_TAGS);
 }
 
 if (!$FEATURE["no_pageedit_js"]) {
 if (isSupereditEnabled(T_PAGE) && $editable) {
 $JS_ONUNLOAD .= "cn3_save_document(false);\n";
 }
 }

?>
