<?php
GUIFactory::setMainGUI( "dialog" );

$HTML_HEADER = false;
$HTML_FOOTER = false;

$HTML_HEAD = "<style type='text/css'> body { display: none; } </style>";

$o_value = "";
$soapjs = '';

if ($cmd == "get_tagname") {
 if ($TEMPLATE_ID) {
 $id = $TEMPLATE_ID;
 $type = "template";
 $table = "templatetag";
 }
 else if ($PAGE_ID) {
 $id = $PAGE_ID;
 $type = "content";
 $table = "contenttag";
 } else if ($OBJTAG_ID) {
 $id = $OBJTAG_ID;
 $type = "obj";
 $table = "objtag";
 } else halt(7,"invalid TEMPLATE_ID($TEMPLATE_ID) or PAGE_ID($PAGE_ID) or OBJTAG_ID($OBJTAG_ID)");
 if (!$construct_id) halt(7,"invalid construct_id($construct_id)");
 $tmp = cmd_tag_generate($construct_id,$id,$table,$type);

 $o_value = $tmp["name"]."\n".$tmp["id"]."\n".htmlentities_utf8($tmp["name"])."\n";
}
else if ( $cmd == "create_translated_tag" )
{
 
 
 
 
 switch ( $o_type )
 {
 case "contenttag":
 $table = "contenttag";
 $type = "content";
 $id = $PAGE_ID;
 break;
 case "templatetag":
 $table = "templatetag";
 $type = "content";
 $id = $TEMPLATE_ID;
 break;
 case "objtag":
 $table = "objtag";
 $type = "obj";
 $id = $OBJTAG_ID;
 break;
 default:
 halt(7, "soap ($cmd): invalid o_type($o_type)");
 }

 switch ( $o_type )
 {
 case "templatetag":
 $part_type = $T_TEMPLATE;
 $cid = $TEMPLATE_ID;
 $code_mother_type = $T_TEMPLATE;
 $code_mother_id = $TEMPLATE_ID;
 node_class("cntemplateobject");
 $baseObj = new CNTemplateObject($TEMPLATE_ID);
 break;
 case "contenttag":
 $part_type = $T_CONTENT;
 $pi = get_pageinfo($PAGE_ID);
 $cid = $pi["content_id"];
 $code_mother_type = $T_PAGE;
 $code_mother_id = $PAGE_ID;
 node_class("cnpageobject");
 $baseObj = new CNPageObject($PAGE_ID);
 break;
 default:
 halt(7, "soap ($cmd): unknown part_type for o_type($o_type)");
 } 

 
 $tmp = cmd_tag_generate($construct_id,$id,$table,$type);
 cmd_tagpart_touch($part_type, $cid);

 if ( $FEATURE['magic_part_value'] && $magic_value ) {
 
 if( !$FEATURE["UTF8"] ) $magic_value = utf8_decode( $magic_value );
 $sql = "SELECT value.id,part.keyword FROM value INNER JOIN part ON part.id = value.part_id WHERE ".sqlf_field($o_type."_id")." = '" . sqlf_escaped($tmp['id']) . "'";
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 if( in_array( $row['keyword'], $MAGIC_PART_NAMES ) ) {
 $sql = "UPDATE value SET value_text = '" . sqlslashes( $magic_value ) . "' WHERE id = ". sqlf_tl_num($row['id']);
 query( $sql );
 }
 }
 
 clear_cache_for_value($type, $tmp['id']);
 }
 node_class("codeparser");
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($code_mother_type, $code_mother_id);

 $parser = new CodeParser($baseObj, false, false, CN_EM_EDIT, false);
 $o_value = $parser->parse($tmp["name"]);
 $preJS = $JS;
 $INPAGEEDIT_TAGS = $parser->getInlineEditableTags();
 $postJS = $JS;
 if ($preJS != $postJS) {
 
 $refresh = "true";
 } else {
 $refresh = "false";
 }
 $soapjs = 'var cn3_tags = new Array(); var cn3_parts = new Array(); var cn3_childable = new Array();';
 $soapjs .= get_inpageeditable_tag_javascript( $INPAGEEDIT_TAGS );

 $o_value = htmlentities_utf8( $o_value );
 preg_match("/<$TAG_PREFIX ?([^>]*)>/i", $tmp["name"], $name );
 $o_value .= "%%".$name[1]."%%";
 if ( is_array( $INPAGEEDIT_TAGS ) )
 {
 $tags = $INPAGEEDIT_TAGS[$name[1]];
 if ( is_array($tags) )
 {
 foreach ( $tags as $key=>$val )
 {
 $o_value .= "$key%%";
 }
 }
 }
 $sql = "SELECT childable FROM construct WHERE id = '"
 . sqlf_escaped($INPAGEEDIT_TAGS[$name[1]]['construct_id']) . "'";
 $rs = query( $sql );
 $o_value .= "<script language=\"javascript\">var childable = '"
 . $rs['arr'][0]['childable'] . "';</script>\n";
}

if ( $callback ) {
 $o_value .= "<script language=\"javascript\">$soapjs$callback($refresh);</script>";
} else if ( $soapjs ) {
 $o_value .= "<script language=\"javascript\">$soapjs</script>";
}
?>
