<?php

global $W_EVENT, $W_TIMER, $W_REACTION, $W_TYPE, $W_OBJECT, $T_FOLDER, $T_GROUP;

$W_TIMER["onpageperiod"] = true;

$W_EVENT["onpagestatus"]["name"] = i18n("cn_on_page_new_status");
$W_EVENT["onpagestatus"]["expandinput"] = "expand_page";
$W_EVENT["onpagestatus"]["expandobjects"] = "expand_page_obj";
$W_EVENT["onpagestatus"]["trigger"][] = "page_id";
$W_EVENT["onpagestatus"]["trigger"][] = "page_status";
$W_EVENT["onpagestatus"]["trigger"][] = "folder_id";
$W_EVENT["onpagestatus"]["trigger"][] = "old_status";
$W_EVENT["onpagestatus"]["trigger_on"][] = "page_status";
$W_EVENT["onpagestatus"]["trigger_on"][] = "folder_id";
$W_EVENT["onpagestatus"]["trigger_on"][] = "old_status";
$W_EVENT["onpagestatus"]["input"][] = "page_id";
$W_EVENT["onpagestatus"]["input"][] = "old_status";
$W_EVENT["onpagestatus"]["output"][] = "page_id";
$W_EVENT["onpagestatus"]["output"][] = "folder_id";
$W_EVENT["onpagestatus"]["output"][] = "page_status";
$W_EVENT["onpagestatus"]["output"][] = "editor_id";
$W_EVENT["onpagestatus"]["output"][] = "creator_id";
$W_EVENT["onpagestatus"]["output"][] = "publisher_id";
$W_EVENT["onpagestatus"]["output"][] = "message";





$W_EVENT["onpagepublish"]["disabled"] = true;

$W_EVENT["onpagepublish"]["name"] = i18n("cn_on_page_publish");
$W_EVENT["onpagepublish"]["expandinput"] = "expand_page";
$W_EVENT["onpagepublish"]["expandobjects"] = "expand_page_obj";
$W_EVENT["onpagepublish"]["trigger"][] = "page_id";
$W_EVENT["onpagepublish"]["trigger"][] = "folder_id";
$W_EVENT["onpagepublish"]["trigger"][] = "old_status";
$W_EVENT["onpagepublish"]["trigger_on"][] = "folder_id";
$W_EVENT["onpagepublish"]["trigger_on"][] = "old_status";
$W_EVENT["onpagepublish"]["input"][] = "page_id";
$W_EVENT["onpagepublish"]["input"][] = "group_id";
$W_EVENT["onpagepublish"]["input"][] = "old_group_id";
$W_EVENT["onpagepublish"]["output"][] = "page_id";
$W_EVENT["onpagepublish"]["output"][] = "group_id";
$W_EVENT["onpagepublish"]["output"][] = "old_group_id";
$W_EVENT["onpagepublish"]["output"][] = "folder_id";
$W_EVENT["onpagepublish"]["output"][] = "page_status";
$W_EVENT["onpagepublish"]["output"][] = "editor_id";
$W_EVENT["onpagepublish"]["output"][] = "creator_id";
$W_EVENT["onpagepublish"]["output"][] = "publisher_id";
$W_EVENT["onpagepublish"]["output"][] = "message";

$W_EVENT["onpageperiod"]["name"] = i18n("cn_on_page_period");
$W_EVENT["onpageperiod"]["expandinput"] = "expand_page";
$W_EVENT["onpageperiod"]["expandobjects"] = "expand_page_obj";
$W_EVENT["onpageperiod"]["trigger"][] = "page_id";
$W_EVENT["onpageperiod"]["trigger"][] = "folder_id";
$W_EVENT["onpageperiod"]["trigger"][] = "create_date";
$W_EVENT["onpageperiod"]["trigger"][] = "edit_date";
$W_EVENT["onpageperiod"]["trigger"][] = "publish_date";
$W_EVENT["onpageperiod"]["trigger_on"][] = "folder_id";
$W_EVENT["onpageperiod"]["trigger_on"][] = "create_date";
$W_EVENT["onpageperiod"]["trigger_on"][] = "edit_date";
$W_EVENT["onpageperiod"]["trigger_on"][] = "publish_date";
$W_EVENT["onpageperiod"]["input"][] = "page_id";
$W_EVENT["onpageperiod"]["input"][] = "time";
$W_EVENT["onpageperiod"]["input"][] = "lasttime";
$W_EVENT["onpageperiod"]["output"][] = "page_id";
$W_EVENT["onpageperiod"]["output"][] = "folder_id";
$W_EVENT["onpageperiod"]["output"][] = "editor_id";
$W_EVENT["onpageperiod"]["output"][] = "creator_id";
$W_EVENT["onpageperiod"]["output"][] = "publisher_id";
$W_EVENT["onpageperiod"]["output"][] = "create_date";
$W_EVENT["onpageperiod"]["output"][] = "edit_date";
$W_EVENT["onpageperiod"]["output"][] = "publish_date";

$W_EVENT["onpagedelete"]["name"] = i18n("cn_on_page_delete");
$W_EVENT["onpagedelete"]["expandinput"] = "expand_page";
$W_EVENT["onpagedelete"]["expandobjects"] = "expand_page_obj";
$W_EVENT["onpagedelete"]["trigger"][] = "page_id";
$W_EVENT["onpagedelete"]["trigger"][] = "folder_id";
$W_EVENT["onpagedelete"]["trigger"][] = "page_status";
$W_EVENT["onpagedelete"]["trigger_on"][] = "page_status";
$W_EVENT["onpagedelete"]["trigger_on"][] = "folder_id";
$W_EVENT["onpagedelete"]["input"][] = "page_id";
$W_EVENT["onpagedelete"]["output"][] = "page_id";
$W_EVENT["onpagedelete"]["output"][] = "folder_id";
$W_EVENT["onpagedelete"]["output"][] = "page_status";
$W_EVENT["onpagedelete"]["output"][] = "editor_id";
$W_EVENT["onpagedelete"]["output"][] = "creator_id";
$W_EVENT["onpagedelete"]["output"][] = "publisher_id";

if($FEATURE['workflow_event_onpagedelete_all_lang']) {

$W_EVENT["onpagedelete_all_lang"]["name"] = i18n("cn_on_page_delete_all_lang");
$W_EVENT["onpagedelete_all_lang"]["expandinput"] = "expand_page";
$W_EVENT["onpagedelete_all_lang"]["expandobjects"] = "expand_page_obj";
$W_EVENT["onpagedelete_all_lang"]["trigger"][] = "page_id";
$W_EVENT["onpagedelete_all_lang"]["trigger"][] = "folder_id";
$W_EVENT["onpagedelete_all_lang"]["trigger"][] = "page_status";
$W_EVENT["onpagedelete_all_lang"]["trigger_on"][] = "page_status";
$W_EVENT["onpagedelete_all_lang"]["trigger_on"][] = "folder_id";
$W_EVENT["onpagedelete_all_lang"]["input"][] = "page_id";
$W_EVENT["onpagedelete_all_lang"]["output"][] = "page_id";
$W_EVENT["onpagedelete_all_lang"]["output"][] = "folder_id";
$W_EVENT["onpagedelete_all_lang"]["output"][] = "page_status";
$W_EVENT["onpagedelete_all_lang"]["output"][] = "editor_id";
$W_EVENT["onpagedelete_all_lang"]["output"][] = "creator_id";
$W_EVENT["onpagedelete_all_lang"]["output"][] = "publisher_id";

}

$W_EVENT["onpagemove"]["name"] = i18n("cn_on_page_move");
$W_EVENT["onpagemove"]["expandinput"] = "expand_page";
$W_EVENT["onpagemove"]["expandobjects"] = "expand_page_obj";
$W_EVENT["onpagemove"]["trigger"][] = "page_id";
$W_EVENT["onpagemove"]["trigger"][] = "folder_id";
$W_EVENT["onpagemove"]["trigger"][] = "to_folder_id";
$W_EVENT["onpagemove"]["trigger"][] = "page_status";
$W_EVENT["onpagemove"]["trigger_on"][] = "folder_id";
$W_EVENT["onpagemove"]["trigger_on"][] = "to_folder_id";
$W_EVENT["onpagemove"]["trigger_on"][] = "page_status";
$W_EVENT["onpagemove"]["input"][] = "page_id";
$W_EVENT["onpagemove"]["input"][] = "to_folder_id";
$W_EVENT["onpagemove"]["output"][] = "page_id";
$W_EVENT["onpagemove"]["output"][] = "folder_id";
$W_EVENT["onpagemove"]["output"][] = "to_folder_id";
$W_EVENT["onpagemove"]["output"][] = "page_status";
$W_EVENT["onpagemove"]["output"][] = "editor_id";
$W_EVENT["onpagemove"]["output"][] = "creator_id";
$W_EVENT["onpagemove"]["output"][] = "publisher_id";

$W_EVENT["onpagecreate"]["name"] = i18n("cn_on_page_create");
$W_EVENT["onpagecreate"]["expandinput"] = "expand_page";
$W_EVENT["onpagecreate"]["trigger"][] = "page_id";
$W_EVENT["onpagecreate"]["trigger"][] = "folder_id";
$W_EVENT["onpagecreate"]["trigger_on"][] = "folder_id"; 
$W_EVENT["onpagecreate"]["input"][] = "page_id";
$W_EVENT["onpagecreate"]["input"][] = "folder_id";
$W_EVENT["onpagecreate"]["output"][] = "page_id";
$W_EVENT["onpagecreate"]["output"][] = "folder_id";
$W_EVENT["onpagecreate"]["output"][] = "page_status";
$W_EVENT["onpagecreate"]["output"][] = "editor_id";
$W_EVENT["onpagecreate"]["output"][] = "creator_id";
$W_EVENT["onpagecreate"]["output"][] = "publisher_id";

$W_EVENT["onpagecopy"]["name"] = i18n("cn_on_page_copy");
$W_EVENT["onpagecopy"]["expandinput"] = "expand_page";
$W_EVENT["onpagecopy"]["trigger"][] = "page_id";
$W_EVENT["onpagecopy"]["trigger"][] = "folder_id";
$W_EVENT["onpagecopy"]["trigger"][] = "to_folder_id";
$W_EVENT["onpagecopy"]["trigger"][] = "page_status";
$W_EVENT["onpagecopy"]["trigger_on"][] = "folder_id";
$W_EVENT["onpagecopy"]["trigger_on"][] = "to_folder_id";
$W_EVENT["onpagecopy"]["trigger_on"][] = "page_status";
$W_EVENT["onpagecopy"]["input"][] = "page_id";
$W_EVENT["onpagecopy"]["input"][] = "new_page_id";
$W_EVENT["onpagecopy"]["input"][] = "to_folder_id";
$W_EVENT["onpagecopy"]["output"][] = "page_id";
$W_EVENT["onpagecopy"]["output"][] = "folder_id";
$W_EVENT["onpagecopy"]["output"][] = "to_folder_id";
$W_EVENT["onpagecopy"]["output"][] = "page_status";
$W_EVENT["onpagecopy"]["output"][] = "editor_id";
$W_EVENT["onpagecopy"]["output"][] = "creator_id";
$W_EVENT["onpagecopy"]["output"][] = "publisher_id";
$W_EVENT["onpagecopy"]["output"][] = "new_page_id";

$W_EVENT["onfoldercreate"]["name"] = i18n("On new folder");
$W_EVENT["onfoldercreate"]["expandinput"] = "expand_folder";
$W_EVENT["onfoldercreate"]["trigger"][] = "folder_id";
$W_EVENT["onfoldercreate"]["trigger"][] = "creator_id";
$W_EVENT["onfoldercreate"]["trigger_on"][] = "folder_id";
$W_EVENT["onfoldercreate"]["input"][] = "folder_id";
$W_EVENT["onfoldercreate"]["input"][] = "new_folder_id";
$W_EVENT["onfoldercreate"]["output"][] = "folder_id";
$W_EVENT["onfoldercreate"]["output"][] = "new_folder_id";
$W_EVENT["onfoldercreate"]["output"][] = "creator_id";
$W_EVENT["onfoldercreate"]["output"][] = "editor_id";

$W_EVENT["onfolderdelete"]["name"] = i18n("cn_on_folder_delete");
$W_EVENT["onfolderdelete"]["expandinput"] = "expand_folder";
$W_EVENT["onfolderdelete"]["trigger"][] = "folder_id";
$W_EVENT["onfolderdelete"]["trigger_on"][] = "folder_id";
$W_EVENT["onfolderdelete"]["input"][] = "folder_id";
$W_EVENT["onfolderdelete"]["input"][] = "old_folder_id";
$W_EVENT["onfolderdelete"]["output"][] = "folder_id";
$W_EVENT["onfolderdelete"]["output"][] = "creator_id";
$W_EVENT["onfolderdelete"]["output"][] = "editor_id";
$W_EVENT["onfolderdelete"]["output"][] = "old_folder_id";

$W_EVENT["onfiledelete"]["name"] = i18n("cn_on_file_delete");
$W_EVENT["onfiledelete"]["expandinput"] = "expand_file";
$W_EVENT["onfiledelete"]["trigger"][] = "file_id";
$W_EVENT["onfiledelete"]["trigger_on"][] = "folder_id";
$W_EVENT["onfiledelete"]["input"][] = "folder_id";
$W_EVENT["onfiledelete"]["input"][] = "file_id";
$W_EVENT["onfiledelete"]["output"][] = "folder_id";
$W_EVENT["onfiledelete"]["output"][] = "creator_id";
$W_EVENT["onfiledelete"]["output"][] = "editor_id";
$W_EVENT["onfiledelete"]["output"][] = "file_id";

$W_REACTION["reaction_msg_status_change"]["name"] = i18n("cn_send_status_message");
$W_REACTION["reaction_msg_status_change"]["input"][] = "page_id";
$W_REACTION["reaction_msg_status_change"]["input"][] = "user_id";
$W_REACTION["reaction_msg_status_change"]["output"][] = "page_id";
$W_REACTION["reaction_msg_status_change"]["output"][] = "user_id";
$W_REACTION["reaction_msg_status_change"]["output"][] = "msg_id";

$W_REACTION["reaction_page_move"]["name"] = i18n("cn_page_move_allang");
$W_REACTION["reaction_page_move"]["input"][] = "page_id";
$W_REACTION["reaction_page_move"]["input"][] = "to_folder_id";
$W_REACTION["reaction_page_move"]["output"][] = "page_id";
$W_REACTION["reaction_page_move"]["output"][] = "folder_id";
$W_REACTION["reaction_page_move"]["triggered"][] = "onpagemove";

$W_REACTION["reaction_page_move_currentlang"]["name"] = i18n("cn_page_move_currentlang");
$W_REACTION["reaction_page_move_currentlang"]["input"][] = "page_id";
$W_REACTION["reaction_page_move_currentlang"]["input"][] = "to_folder_id";
$W_REACTION["reaction_page_move_currentlang"]["output"][] = "page_id";
$W_REACTION["reaction_page_move_currentlang"]["output"][] = "folder_id";
$W_REACTION["reaction_page_move_currentlang"]["triggered"][] = "onpagemove";

$W_REACTION["reaction_page_copy"]["name"] = i18n("cn_page_copy");
$W_REACTION["reaction_page_copy"]["input"][] = "page_id";
$W_REACTION["reaction_page_copy"]["input"][] = "to_folder_id";
$W_REACTION["reaction_page_copy"]["output"][] = "page_id";
$W_REACTION["reaction_page_copy"]["output"][] = "folder_id";
$W_REACTION["reaction_page_copy"]["output"][] = "new_page_id";
$W_REACTION["reaction_page_copy"]["triggered"][] = "onpagecopy";

$W_REACTION["reaction_set_page_status"]["name"] = i18n("cn_set_page_status");
$W_REACTION["reaction_set_page_status"]["input"][] = "page_id";
$W_REACTION["reaction_set_page_status"]["input"][] = "new_page_status";
$W_REACTION["reaction_set_page_status"]["output"][] = "page_id";
$W_REACTION["reaction_set_page_status"]["output"][] = "page_status";
$W_REACTION["reaction_set_page_status"]["triggered"][] = "onpagestatus";







$W_REACTION["reaction_page_proof"]["disabled"] = true;

$W_REACTION["reaction_page_proof"]["name"] = i18n("cn_page_proof");
$W_REACTION["reaction_page_proof"]["input"][] = "group_id";
$W_REACTION["reaction_page_proof"]["input"][] = "page_id";
$W_REACTION["reaction_page_proof"]["output"][] = "group_id";
$W_REACTION["reaction_page_proof"]["output"][] = "page_id";
$W_REACTION["reaction_page_proof"]["triggered"][] = "onpagepublish";

$W_REACTION["reaction_folder_setperm"]["name"] = i18n("Set folder permission");
$W_REACTION["reaction_folder_setperm"]["input"][] = "folder_id";
$W_REACTION["reaction_folder_setperm"]["input"][] = "permbit";
$W_REACTION["reaction_folder_setperm"]["input"][] = "permvalue";
$W_REACTION["reaction_folder_setperm"]["output"][] = "folder_id";
$W_REACTION["reaction_folder_setperm"]["output"][] = "permbit";
$W_REACTION["reaction_folder_setperm"]["output"][] = "permvalue";


$W_REACTION["reaction_folder_move"]["name"] = i18n("cn_folder_move");
$W_REACTION["reaction_folder_move"]["input"][] = "folder_id";
$W_REACTION["reaction_folder_move"]["input"][] = "to_folder_id";
$W_REACTION["reaction_folder_move"]["output"][] = "folder_id";
$W_REACTION["reaction_folder_move"]["output"][] = "to_folder_id";
$W_REACTION["reaction_folder_move"]["triggered"][] = "onfoldermove";

$W_REACTION["reaction_file_move"]["name"] = i18n("cn_file_move");
$W_REACTION["reaction_file_move"]["input"][] = "file_id";
$W_REACTION["reaction_file_move"]["input"][] = "to_folder_id";
$W_REACTION["reaction_file_move"]["output"][] = "file_id";
$W_REACTION["reaction_file_move"]["output"][] = "to_folder_id";
$W_REACTION["reaction_file_move"]["triggered"][] = "onfilemove";

$W_TYPE["page_id"]["alias"][] = "new_page_id";
$W_TYPE["page_id"]["name"] = i18n("page");
$W_TYPE["page_id"]["type"] = "id";

$W_TYPE["new_page_id"]["name"] = i18n("cn_page_new");

$W_TYPE["folder_id"]["alias"][] = "to_folder_id";
$W_TYPE["folder_id"]["alias"][] = "new_folder_id";
$W_TYPE["folder_id"]["alias"][] = "old_folder_id";
$W_TYPE["folder_id"]["name"] = i18n("folder");
$W_TYPE["folder_id"]["type"] = "tree";
$W_TYPE["folder_id"]["input"] = "selector";
$W_TYPE["folder_id"]["init"] = "init_folder_selector";
$W_TYPE["folder_id"]["type_id"] = $T_FOLDER;

$W_TYPE["to_folder_id"]["name"] = i18n("cn_to_folder");
$W_TYPE["new_folder_id"]["name"] = i18n("new folder");
$W_TYPE["old_folder_id"]["name"] = i18n("cn_folder_to_delete");

$W_TYPE["user_id"]["alias"][] = "editor_id";
$W_TYPE["user_id"]["alias"][] = "creator_id";
$W_TYPE["user_id"]["alias"][] = "publisher_id";

$W_TYPE["editor_id"]["name"] = i18n("editor");
$W_TYPE["editor_id"]["accept"][] = "user_id";

$W_TYPE["creator_id"]["name"] = i18n("creator");
$W_TYPE["creator_id"]["accept"][] = "user_id";

$W_TYPE["publisher_id"]["name"] = i18n("publisher");
$W_TYPE["publisher_id"]["accept"][] = "user_id";

$W_TYPE["period"]["alias"][] = "create_date";
$W_TYPE["period"]["alias"][] = "edit_date";
$W_TYPE["period"]["alias"][] = "publish_date";

$W_TYPE["create_date"]["name"] = i18n("cn_creation_date");

$W_TYPE["edit_date"]["name"] = i18n("cn_modify_date");

$W_TYPE["publish_date"]["name"] = i18n("cn_publish_date");

$W_TYPE["permbit"]["name"] = i18n("Permission bit");
$W_TYPE["permbit"]["type"] = "int";
$W_TYPE["permbit"]["input"]= "int";

$W_TYPE["permvalue"]["name"] = i18n("Permission value");
$W_TYPE["permvalue"]["type"] = "int";
$W_TYPE["permvalue"]["input"] = "check";

$W_TYPE["page_status"]["alias"][] = "old_status";
$W_TYPE["page_status"]["name"] = i18n("cn_page_status");
$W_TYPE["page_status"]["type"] = "id";
$W_TYPE["page_status"]["input"] = "select";
$W_TYPE["page_status"]["values"][0] = i18n("cn_in_progress");
$W_TYPE["page_status"]["values"][1] = i18n("cn_to_publish");

$W_TYPE["page_status"]["values"][3] = i18n("cn_offline");
$W_TYPE["page_status"]["values"][4] = i18n("queued");
$W_TYPE["page_status"]["values"][5] = i18n("cn_timemanagement ");

$W_TYPE["new_page_status"]["name"] = i18n("cn_page_new_status");
$W_TYPE["new_page_status"]["type"] = "id";
$W_TYPE["new_page_status"]["input"] = "select";
$W_TYPE["new_page_status"]["accept"][] = "page_status";
$W_TYPE["new_page_status"]["values"][0] = i18n("cn_in_progress");
$W_TYPE["new_page_status"]["values"][1] = i18n("cn_to_publish");
$W_TYPE["new_page_status"]["values"][3] = i18n("cn_server_offline");

$W_TYPE["old_status"]["name"] = i18n("cn_page_old_status");

$W_TYPE["group_id"]["alias"][] = "to_group_id";
$W_TYPE["group_id"]["name"] = i18n("group");
$W_TYPE["group_id"]["type"] = "tree";
$W_TYPE["group_id"]["input"] = "selector";
$W_TYPE["group_id"]["init"] = "init_group_selector";
$W_TYPE["group_id"]["type_id"] = $T_GROUP;

$W_TYPE["file_id"]["name"] = i18n("file");

$W_OBJECT[$T_FOLDER]["sessionvar"] = "FOLDER_ID";
$W_OBJECT[$T_FOLDER]["get_trigger"] = "folder_get_event_trigger";



function init_group_selector($prefix, $info, $scope) {
 return new group_selector($prefix,$info,$node_folder_id);
}


function init_folder_selector($prefix, $info, $scope) {
 global $FEATURE;

 if ( ($scope == WF_SCOPE_LOCAL) && !($FEATURE["no_node_isolation"]) )
 {
 global $FOLDER_ID;
 if ($FOLDER_ID) {
 $sql = "SELECT folder_id FROM node, folder WHERE node.id=folder.node_id AND folder.id=".sqlf_tl_num($FOLDER_ID);
 $rs = query($sql);
 $node_folder_id = $rs["arr"][0]["folder_id"];
 } else {
 $node_folder_id = 0;
 }
 }
 else
 {
 $node_folder_id = 0;
 }
 return new folder_selector($prefix,$info,$node_folder_id);
}

function folder_get_event_trigger($t_type, $info = "") {
 global $T_FOLDER, $FOLDER_ID;

 $out = array();

 $out["folder_id"]["val"] = $FOLDER_ID;
 $out["folder_id"]["info"] = ($info["folder_id"]["info"])?$info["folder_id"]["info"]:"tree:$T_FOLDER";
 $out["o_type"] = $t_type;
 $out["o_id"] = $FOLDER_ID;

 return $out;
}

function content_get_event_trigger($t_type, $info = "") {
 global $T_CONTENT;

 $out = array();

 $out["folder_id"]["info"] = "global";
 $out["content_id"]["val"] = 1;
 $out["content_id"]["info"] = ($info["content_id"]["info"])?$info["content_id"]["info"]:"tree:$T_CONTENT:recursive";
 $out["o_type"] = $t_type;
 $out["o_id"] = 1;

 return $out;
}


function expand_page($event, $val) {

 global $PAGE_STATUS;

 $out = $val;
 
 $pid = $val["page_id"];
 if (!$pid) return $val;
 
 if ($event == "onpageperiod") {
 $sql = "SELECT id AS page_id, name, folder_id, editor AS editor_id, creator AS creator_id, publisher AS publisher_id, cdate AS create_date, edate AS edit_date, pdate AS publish_date 
				FROM page WHERE id = ".sqlf_tl_num($pid);
 } else {
 $sql = "SELECT id AS page_id, name, folder_id, status AS page_status, editor AS editor_id, creator AS creator_id, publisher AS publisher_id 
				FROM page WHERE id = ".sqlf_tl_num($pid);
 }
 $rs = query($sql);
 $info = array();
 foreach ($rs["arr"][0] as $key=>$val) {
 if (is_numeric($key)) continue;
 $info[$key] = $val;
 }

 if ( ! $info) {
 return false;
 }

 if ($event == "onpagestatus") {
 $user = get_userinfo($rs["arr"][0]["publisher_id"]);
 $info["message"] = "Die Seite ".$info["name"]." wurde von ".$user["firstname"]." ".$user["lastname"]." auf den Status ".$PAGE_STATUS[$info["page_status"]]." gesetzt.";
 }
 else if ($event == "onpageperiod") {

 $pageinfo = get_pageinfo ($info["page_id"]);
 if ( ! $pageinfo) {
 return false;
 }
 $folderinfo = get_folderinfo ($pageinfo["folder_id"], true);
 if ( ! $folderinfo) {
 return false;
 }
 $nodeinfo = get_nodeinfo ($folderinfo["node_id"]);
 if ( ! $nodeinfo) {
 return false;
 }

 $info["full_path"] = $folderinfo["fullpath"]["name"];
 $info["host"] = $nodeinfo["host"];

 global $WORKFLOW_MSG_PAGEAGE;
 if ($WORKFLOW_MSG_PAGEAGE) {
 $tmp = $WORKFLOW_MSG_PAGEAGE;

 $info["full_path"] = $folderinfo["fullpath"]["name"];
 $info["host"] = $nodeinfo["host"];
 
 foreach ($info as $key=>$val) {
 $tmp = str_replace("<".$key.">", $val, $tmp);
 }
 }
 
 else {
 
 $tmp = i18n ("The page ({0}) (<pageid {1}>) in folder ({2}) in node ({3}) has not been modified for a while. Please check if the content is still up to date.", 0, $info["name"], $info["page_id"], $folderinfo["fullpath"]["name"], $nodeinfo["host"]);
 }
 
 $info["message"] = $tmp;
 
 }
 else if ($event == "onpagepublish") {
 
 $out['old_group_id'] = 3;
 }
 $out += $info;
 
 return $out;
}

function expand_folder($event, $val) {
 
 $out = $val;
 $fid = $val["folder_id"];
 if (!$fid) return $val;

 $sql = "SELECT mother, name, type_id, pub_dir, creator, editor, description, startpage_id FROM folder WHERE id = ".sqlf_tl_num($fid);
 $rs = query($sql);
 $r = $rs["arr"][0];

 $out["mother_id"] = $r["mother"];
 $out["type_id"] = $r["type_id"];
 $out["creator_id"]= $r["creator"];
 $out["editor_id"] = $r["editor"];
 $out["pub_dir"] = $r["pub_dir"];
 $out["description"] = $r["description"];
 $out["startpage_id"] = $r["startpage_id"];
 
 return $out;
}

function expand_file($event, $val) {
 $out = $val;
 $fid = $val["file_id"];
 if (!$fid) return $val;

 $sql = "SELECT name, filetype, filesize, creator, editor, cdate, edate, description, folder_id FROM contentfile WHERE id = ".sqlf_tl_num($fid);
 $rs = query($sql);
 $r = $rs["arr"][0];

 $out["name"] = $r["name"];
 $out["filetype"] = $r["filetype"];
 $out["creator_id"]= $r["creator"];
 $out["editor_id"] = $r["editor"];
 $out["cdate"] = $r["cdate"];
 $out["edate"] = $r["edate"];
 $out["description"] = $r["description"];
 $out["folder_id"] = $r["folder_id"];

 return $out;
}

function expand_page_obj($event, $input, $missing) {
 $out = array();

 if ($missing == "page_id") {
 
 $sql = "SELECT id FROM page";
 if ($input["folder_id"]) $sql .= " WHERE folder_id = ".sqlf_tl_num($input["folder_id"]);
 $rs = query($sql);

 while (list($key,$val) = each($rs["arr"])) {
 $i = $input;
 $i["page_id"] = $val["id"];
 $out[] = $i;
 }
 
 } else $out = array($input);

 return $out;
}

function reaction_msg_status_change($reaction, $props, $id, &$handled) {
 global $USER_ID, $PAGE_STATUS;
 
 $out = $props;

 $pid = $props["page_id"];
 $uid = $props["user_id"];

 if (!$pid || !$uid) return $out;

 $sql = "SELECT name, status, folder_id FROM page WHERE id = ".sqlf_tl_num($pid);
 $rs = query($sql);

 $sql = "SELECT name FROM folder WHERE id = ".sqlf_tl_num($rs["arr"][0]["folder_id"]);
 $rs1 = query($sql);

 $sql = "SELECT firstname, lastname FROM systemuser WHERE id = ".sqlf_tl_num($uid);
 $rs2 = query($sql);

 $name = $rs["arr"][0]["name"];
 $status = $PAGE_STATUS[$rs["arr"][0]["status"]];
 $folder = $rs1["arr"][0]["name"];
 $user = $rs2["arr"][0]["lastname"]." ".$rs2["arr"][0]["firstname"];
 if ($props["old_status"]) $von = " von '".$PAGE_STATUS[$rs["arr"][0]["status"]]."'";

 $msg = "Die Seite $name im Ordner $folder wurde von $user$von auf '$status' gesetzt.";
 $out["msg_id"] = msg($msg, $uid, $USER_ID);

 $handled = true;

 return $out;
}




function page_make_names_unique( $page_id, $folder_id ) {
 $changed = false;
 $pageinfo = get_pageinfo( $page_id );
 $lastfilename = $filename = $pageinfo['filename'];
 $i = 0;
 while( $i++ < 50 ) {
 
 $filename = unique_page_filename( $filename, $pageinfo['folder_id'], $page_id, $page_id );
 $filename = unique_page_filename( $filename, $folder_id, $page_id, $page_id );
 if( $lastfilename == $filename ) {
 break;
 }
 $lastfilename = $filename;
 }
 if( $filename != $pageinfo['filename'] ) {
 
 $changed = true;
 } else {
 
 }
 
 
 $name = $pagename = $pageinfo["name"];
 
 $sql = "SELECT id FROM page WHERE name = '".sqlslashes($pagename)."' AND folder_id = ".sqlf_tl_num($folder_id);
 $rs = query ($sql);
 
 while ($rs["num"] > 0) {
 $changed = true;
 
 if (!$i) $tmp = "";
 else $tmp = " ".($i+1);
 
 $name = i18n( "Copy {0} of page {1}", 0, $tmp, $pagename );
 $sql = "SELECT id FROM page WHERE name = '".sqlslashes($name)."' AND (folder_id = ".sqlf_tl_num($folder_id)." OR folder_id = ".sqlf_tl_num($pageinfo["folder_id"]).")";
 $rs = query($sql);
 $i++;
 }

 if( $changed ) {
 cmd_page_update($page_id, $name, $pageinfo["description"], $pageinfo["priority"], $filename, $pageinfo["template_id"], $pageinfo["status"],
 $pageinfo["contentgroup_id"]);
 }
}

function page_make_names_unique_all_contentgroups( $page_id, $folder_id ) {
 $pageinfo = get_pageinfo( $page_id );
 if( $pageinfo['contentset_id'] ) {
 $sql = "SELECT id FROM page WHERE contentset_id = '".sqlf_escaped($pageinfo['contentset_id'])."'";
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 page_make_names_unique( $row['id'], $folder_id );
 }
 } else {
 page_make_names_unique( $page_id, $folder_id );
 }
}
function reaction_page_move($reaction, $arr, $id, &$handled, $userids) {
 _reaction_page_move($reaction, $arr, $id, $handled, $userids, true);
}

function reaction_page_move_currentlang($reaction, $arr, $id, &$handled, $userids) {
 
 
 $cs = cmd_page_createcs();
 $sql = "UPDATE page SET contentset_id = ".sqlf_tl_num($cs)." WHERE id = " . sqlf_tl_num($arr["page_id"]);
 query($sql);
 _reaction_page_move($reaction, $arr, $id, $handled, $userids, false);
}

function _reaction_page_move($reaction, $arr, $id, &$handled, $userids, $all_contentgroups) {
 global $USER_ID, $EVENT_IS_HANDLED, $DEBUG, $WF_REACTION_PAGE_MOVE_USER;

 if($DEBUG['echo'] && $DEBUG['workflow']) {
 echo "_reaction_page_move ... $reaction - $id - $all_contentgroups ..<br>";
 }
 $page_id = $arr["page_id"];
 $folder_id = $arr["to_folder_id"];
 $uid = ($userids["to_folder_id"])?$userids["to_folder_id"]:$USER_ID;
 if (isset($WF_REACTION_PAGE_MOVE_USER)) {
 $uid = $WF_REACTION_PAGE_MOVE_USER;
 } 
 $pageinfo = get_pageinfo ($arr["page_id"]);

 
 if ($folder_id == $pageinfo["folder_id"]) {
 $handled = true;
 return $arr;
 }

 $changed = false;

 page_make_names_unique_all_contentgroups( $page_id, $folder_id );
 






























 cmd_page_move(array($page_id=>true),$folder_id, $uid, $all_contentgroups);

 $arr["folder_id"] = $folder_id;
 $handled = true;

 if($all_contentgroups) {
 
 
 $sql = "SELECT id FROM page WHERE contentset_id = '" . sqlf_escaped($pageinfo['contentset_id']) . "'";
 $rs = query( $sql );
 foreach($rs['arr'] as $row) {
 $EVENT_IS_HANDLED[] = array( 'val' => array( 'page_id' => $row['id'],
 'to_folder_id' => $folder_id,
 ),
 );
 }
 }

 return $arr;
}




function reaction_folder_move($reaction, $arr, $id, &$handled, $userids) {
 
 $folder_id = $arr["folder_id"];
 $to_folder_id = $arr["to_folder_id"];

 $folderinfo = get_folderinfo($folder_id);

 
 $newfoldername = $foldername = $folderinfo["name"];

 $sql = "SELECT id FROM folder WHERE name = '".sqlslashes($newfoldername)."' AND mother = ".sqlf_tl_num($to_folder_id);
 $rs = query ($sql);
 $i = 0;

 while ($rs["num"] > 0) {
 $changed = true;

 if ($i == 0) {
 $tmp = "";
 } else {
 $tmp = "".($i);
 }

 $newfoldername = i18n( "Copy {0} of {1}", 0, $tmp, $foldername);
 $sql = "SELECT id FROM folder WHERE name = '".sqlslashes($newfoldername)."' AND (mother = ".sqlf_tl_num($to_folder_id)." OR mother = ".sqlf_tl_num($folderinfo["mother"]).")";
 $rs = query($sql);
 $i++;
 }

 
 if ($changed) {
 cmd_folder_update($folder_id, $newfoldername, $folderinfo["pub_dir"], $folderinfo["description"]);
 }

 
 cmd_folder_move($folder_id, $to_folder_id);
 $handled = true;

 return $arr;
}




function reaction_file_move($reaction, $arr, $id, &$handled, $userids) {
 
 $file_id = $arr["file_id"];
 $folder_id = $arr["folder_id"];
 $to_folder_id = $arr["to_folder_id"];
 $filename = $arr["name"];

 
 if ($folder_id == $to_folder_id) {
 $handled = true;
 return $arr;
 }

 $new_filename = suggest_new_filename($filename, $to_folder_id, $file_id);

 
 if ($new_filename != $filename) {
 cmd_file_update($file_id, $folder_id, $new_filename, $arr["description"]);
 }

 cmd_file_move($file_id, $to_folder_id);
 $handled = true;

 return $arr;
}

function reaction_page_copy($reaction, $arr, $id, &$handled, $userids) {
 $page_id = $arr["page_id"];
 $folder_id = $arr["to_folder_id"];
 $pid = page_copy($page_id,$folder_id, true);
 trigger_event("onpagecopy",array("page_id"=>$page_id,"new_page_id"=>$pid,"to_folder_id"=>$folder_id),$id);
 $arr["folder_id"] = $folder_id;
 $arr["new_page_id"] = $pid;
 return $arr;
}

function reaction_set_page_status($reaction, $arr, $id, &$handled) {
 $page_id = $arr["page_id"];
 $status = $arr["new_page_status"];
 page_status($page_id, $status);
 trigger_event("onpagestatus",array("page_id"=>$page_id,"page_status"=>$status,"old_status"=>$arr["page_status"]), $id);
 $arr["page_status"] = $status;
 return $arr;
}

function reaction_page_proof($reaction, $arr, $id, &$handled) {
 $page_id = $arr["page_id"];
 $group_id = $arr["group_id"];
 $old_group_id = $arr["old_group_id"];
 echo "Seite $page_id zu pr�fen! Alle der Gruppe $group_id werden benachrichtigt.".var_dump($arr);;
 trigger_event("onpagepublish",array("page_id"=>$page_id,"group_id"=>$group_id), $id);
 $handled = true;
 return $arr;
}

function reaction_folder_setperm($reaction, $arr, $id, &$handled) {
 global $T_FOLDER;
 
 $folder_id = $arr["folder_id"];
 $permbit = $arr["permbit"];
 $permvalue = $arr["permvalue"];
 
 node_include("perm");
 
 
 $sql = "SELECT id FROM usergroup";
 $rs = query($sql);
 
 foreach ($rs["arr"] as $r) {
 $group_id = $r["id"];
 $perms = perm_group($group_id, $T_FOLDER, $folder_id);
 if ($perms[$permbit] == $permvalue) continue;
 $perms[$permbit] = $permvalue?1:0;
 perm_set_perms($group_id, $T_FOLDER, $folder_id, perm2string($perms));
 }
 
 return $arr;
}

?>
