<?php
$title = ($translation) ? i18n("translation_page") . ": " . $name : $name;
echo dialog($f,0,"normal",$title,$ICO_PAGE);
global $STAG_PREFIX;
?>

<?php 


if (isset($PAGE_ID)) {
?>

<script type="text/javascript">
jQuery(document).ready(function() {
	getSyncInfo();
});

function getSyncInfo() {
	// check the page's sync status
	jQuery.ajax({
		url : '<?php echo $PORTLETAPP_PREFIX;?>rest/page/load/<?php echo $PAGE_ID;?>?sid=<?php echo $SID;?>&translationstatus=true&ts=' + (new Date()).getTime(),
		type : 'GET',
		dataType : 'json', 
		success : function(data) {
			if (!data.page.translationStatus || !data.page.translationStatus.pageId) {
				// no translation status received - exiting
				return;				
			}
			var t = data.page.translationStatus;
			showSyncInfo(t);
		}
	});
}

function showSyncInfo(syncInfo) {

	// find the syncinfo cell
	var syncInfoCell = jQuery('td#syncinfo');
	if (!syncInfoCell[0]) {
		// not found, so create it
		jQuery('.dialog>table tr:last').after('<tr><td><?php echo i18n("Translation");?></td><td id="syncinfo"></td></tr>');
		syncInfoCell = jQuery('td#syncinfo');
	}

	// clear the cell first
	syncInfoCell.empty();

	// insert the sync info
	syncInfoCell.append('<p><?php echo i18n("translation_linked_to");?> ' +
			'<img style="vertical-align: -4px;" src="<?php echo $STAG_PREFIX ?>?do=14203&module=content&base=doc.png&lang=' + syncInfo.language + '" alt="' + 
			syncInfo.name +'"/> ' + syncInfo.name + ' ('+syncInfo.language+' <?php echo i18n("Version")?> ' + syncInfo.version + ') </p>');
	// sync button (only if out of sync)
	if (!syncInfo.inSync) {
		var buttonSrc = '?do=15&amp;text=<?php echo i18n("Synchronize");?> (<?php echo i18n("Version")?> ' + syncInfo.latestVersion.version +')';
		syncInfoCell.append('<input id="syncbtn" type="image" src="'+buttonSrc+'" ' +
			'title="<?php echo i18n("Synchronize");?>" alt="<?php echo i18n("Synchronize");?>" border="0"/>');
		jQuery('#syncbtn').click(function() {
			var saveRequestBody = {
				page : {
					id : <?php echo $PAGE_ID;?>,
					translationStatus : {
						pageId : syncInfo.pageId,
						versionTimestamp : syncInfo.latestVersion.versionTimestamp
					}
				}
			};
			// save the page with new sync info
			jQuery.ajax({
				url : '<?php echo $PORTLETAPP_PREFIX;?>rest/page/save/<?php echo $PAGE_ID;?>?sid=<?php echo $SID;?>',
				type : 'POST',
				dataType : 'json',
				contentType: 'application/json; charset=utf-8',
				data : jQuery.toJSON(saveRequestBody),
				success : function(data) {
					getSyncInfo();
				}
			});

			return false;
		});
	}
}

</script>
<?php 
}
?>
