<?php
function checkTopStreamExistance($prefix, $stream) {
 global $FEATURE, $CUSTOM_STREAM_DIRECTORY, $NODEPATH;
 if (!$stream) {
 return false;
 }

 $custpos = strpos( $stream, '.custom-stream' );
 if( $FEATURE['custom_streams'] && $custpos > 0 ) {
 $filename = "$CUSTOM_STREAM_DIRECTORY/$prefix.".substr($stream, 0, $custpos);
 } else {
 $filename = "$NODEPATH/modules/system/template/standard/images/streams/$prefix.$stream";
 }

 return file_exists($filename);
}








function getstream($prefix, $override = null) {
 global $MAINTENANCE_MODE, $MYSTREAM, $MYSTREAM_DEFAULT;

 
 if ($prefix == "top" && $MAINTENANCE_MODE) {
 return "system-maintenance.jpg";
 }

 $stream = $override ? $override : $MYSTREAM;

 if ($stream == "system-maintenance.jpg" && !$MAINTENANCE_MODE) {
 $stream = $MYSTREAM_DEFAULT;
 }

 if (!checkTopStreamExistance($prefix, $stream)) {
 if (!checkTopStreamExistance($prefix, $MYSTREAM_DEFAULT)) {
 return "sunflower.jpg";
 } else {
 return $MYSTREAM_DEFAULT;
 }
 } else {
 return $stream;
 }
}


?>
