<?php








function pretty_perm_group($groupId, $objectType, $objectId)
{
 
 $groupPermissionBits = perm_group($groupId, $objectType, $objectId);
 $groupRoles = null;

 
 if ($GLOBALS['FEATURE']['roles']) {
 if (in_array($objectType, array(T_FOLDER, T_DOMAIN))) {
 $groupRoles = get_roles_for_group($groupId, $objectType, $objectId);
 }
 }

 return pretty_perm_humanReadable($objectType, $groupPermissionBits, $groupRoles);
}








function pretty_perm_humanReadable($objectType, $groupPermissionBits, $groupRoles = null)
{
 
 $curr_group = "-1";

 if (is_array($GLOBALS['PERM'][$objectType])) {
 if ($DEBUG["echo"] && $GLOBALS['DEBUG']['perm']) {
 echo "\n\n\nGROUP($group_id) O_TYPE($objectType) BIT/SET,:\n";
 }

 reset($GLOBALS['PERM'][$objectType]);
 while (list($bit, $val) = each($GLOBALS['PERM'][$objectType])) {
 if ($curr_group != $val["group"]) {

 
 if (empty($outp)) {
 $outp .= " ";
 }
 else {
 $outp.= ") ";
 }

 $curr_group = $val["group"];
 $outp .= "$curr_group (";
 }

 if ($GLOBALS['DEBUG']['perm']) {
 echo "$bit/" . $groupPermissionBits[$bit] . ",";
 }

 
 $outp .= ($groupPermissionBits[$bit]) ? $val["short"] : "-";
 }
 }

 
 if ($outp) {
 $outp .= ")";
 }

 if ($GLOBALS['FEATURE']['roles'] && $groupRoles !== null) {
 if ($objectType == T_FOLDER || $objectType == T_DOMAIN) {
 $outp .= ' ' . i18n('Roles') . ' (';

 if (count($groupRoles) > 0) {
 $outp .= count($groupRoles);
 }
 } else {
 $outp .= '-';
 }

 $outp .= ')';
 }

 return $outp;
}


function pretty_perm_help($group_id, $o_type, $o_id) {

 global $PERM, $T_FOLDER, $LANGUAGE, $T_DOMAIN;

 


 if (is_array($PERM[$o_type])) {

 reset($PERM[$o_type]);
 while (list($bit, $val) = each($PERM[$o_type])) {
 if ($curr_group != $val["group"]) {
 
 $curr_group = $val["group"];
 $help .= "<b>$curr_group</b><br>";
 }
 $help .= $val["short"]." : ".$val["name"]."<br>";
 }
 }

 if( $o_type == $T_FOLDER || $o_type == $T_DOMAIN ) {
 $roles = get_roles_for_group( $group_id, $o_type, $o_id );
 if( count( $roles ) > 0 ) {
 $help .= '<br><br><b>'.i18n('Roles').'</b><br>';
 }
 foreach( $roles as $role ) {
 $help .= $role['name'] . '<br>';
 }
 if( count( $roles ) > 0 ) {
 $help .= '<br>';
 }
 }

 return $help;
}

function get_roles_for_group($group_id, $obj_type, $obj_id) {
 global $LANGUAGE;
 $sql = "SELECT role.name_id,dicname.value AS name FROM role_usergroup INNER JOIN role_usergroup_assignment ON role_usergroup_assignment.role_usergroup_id = role_usergroup.id INNER JOIN role ON role_usergroup.role_id = role.id INNER JOIN dicuser AS dicname ON dicname.output_id = role.name_id AND dicname.language_id = ".sqlf_tl_num($LANGUAGE)." WHERE role_usergroup.usergroup_id = ".sqlf_tl_num($group_id)." AND role_usergroup_assignment.obj_id = ".sqlf_tl_num($obj_id)." AND role_usergroup_assignment.obj_type = ".sqlf_tl_num($obj_type);
 $rs = query( $sql );
 return $rs['arr'];
}


function pretty_perm_js() {

 global $ASSDELAY;

 if (!$ASSDELAY) $ASSDELAY = 800;

 $outp = "
<script type=\"text/javascript\">

var ass_text;

function ph(event,help) {
  t = get_mouse(event);
  if (help) {
    ass_text = help;
    setTimeout('phs('+t[0]+','+t[1]+')',".$ASSDELAY.");
  }
}
function phs(mouseX,mouseY) {
  gtx_ass_showtooltip( mouseX, mouseY, 'Info', ass_text, '' );
  if (top.main.ass && ass_text != '')
    top.main.ass.ass_help('".i18n('desc')."', ass_text);
  else
    phr();
}
function phr() {
  ass_text='';
  gtx_ass_hidetooltip();
  if (top.main.ass)
    top.main.ass.ass_reset();
}
</script>".'
<div id="listInfos" class="listInfos">
		
	<h6 id="assHeader"></h6>
	<div id="assItemTitle" class="title"></div>
	<p id="assText"></p>
	</div>
';

 return $outp;
}
